#ifndef _MODBUS_MSXE171X_CLIENT_DEFINITION_H_
#define _MODBUS_MSXE171X_CLIENT_DEFINITION_H_

/* this file has been generated by gModbus on Tue May  3 10:16:09 2016*/

#include "common_modbus_clientlib.h"



/* Symbolic names for register */
enum {
MSXE17XX__MFSINCOSREADALL=1000,
MSXE17XX__MFSINCOSREAD0=1050,
MSXE17XX__MFSINCOSREAD1=1100,
MSXE17XX__MFSINCOSREAD2=1150,
MSXE17XX__MFSINCOSREAD3=1200,
MSXE17XX__MFSINCOSREADABSPOS0=2000,
MSXE17XX__MFSINCOSREADABSPOS1=2050,
MSXE17XX__MFSINCOSREADABSPOS2=2100,
MSXE17XX__MFSINCOSREADABSPOS3=2150,
MSXE17XX__MFSINCOSREADABSPOSALL=2200,
MSXE17XX__DIGITALIOREADALLCHANNELSVALUE=7000,
MSXE17XX__DIGITALIOTESTSHORTCIRCUIT=7050,
MSXE17XX__IOWATCHDOGGETSTATUSANDVALUE=8000,
};

#ifdef WIN32
#pragma pack(1)
#endif // WIN32

struct MSXE17xx__MFSinCosReadAll_parameters_t
{
	uint32_t ulValues[4];
	uint32_t ulMeasureErrors[4];
 } __PACKED;

struct MSXE17xx__MFSinCosRead0_parameters_t
{
	uint32_t ulValue;
	uint32_t ulMeasureError;
 } __PACKED;

struct MSXE17xx__MFSinCosRead1_parameters_t
{
	uint32_t ulValue;
	uint32_t ulMeasureError;
 } __PACKED;

struct MSXE17xx__MFSinCosRead2_parameters_t
{
	uint32_t ulValue;
	uint32_t ulMeasureError;
 } __PACKED;

struct MSXE17xx__MFSinCosRead3_parameters_t
{
	uint32_t ulValue;
	uint32_t ulMeasureError;
 } __PACKED;

struct MSXE17xx__MFSinCosReadAbsPos0_parameters_t
{
	uint32_t ulValue;
	uint32_t ulAbsPos;
	uint32_t ulAbsPosStatus;
	uint32_t ulMeasureError;
 } __PACKED;

struct MSXE17xx__MFSinCosReadAbsPos1_parameters_t
{
	uint32_t ulValue;
	uint32_t ulAbsPos;
	uint32_t ulAbsPosStatus;
	uint32_t ulMeasureError;
 } __PACKED;

struct MSXE17xx__MFSinCosReadAbsPos2_parameters_t
{
	uint32_t ulValue;
	uint32_t ulAbsPos;
	uint32_t ulAbsPosStatus;
	uint32_t ulMeasureError;
 } __PACKED;

struct MSXE17xx__MFSinCosReadAbsPos3_parameters_t
{
	uint32_t ulValue;
	uint32_t ulAbsPos;
	uint32_t ulAbsPosStatus;
	uint32_t ulMeasureError;
 } __PACKED;

struct MSXE17xx__MFSinCosReadAbsPosAll_parameters_t
{
	uint32_t ulValues[4];
	uint32_t ulAbsPos[4];
	uint32_t ulAbsPosStatus[4];
	uint32_t ulMeasureErrors[4];
 } __PACKED;

struct MSXE17xx__DigitalIOReadAllChannelsValue_parameters_t
{
	uint32_t ulChannelsValue;
 } __PACKED;

struct MSXE17xx__DigitalIOTestShortCircuit_parameters_t
{
	uint32_t ulValue;
 } __PACKED;

struct MSXE17xx__IOWatchdogGetStatusAndValue_parameters_t
{
	uint32_t ulStatus;
	uint32_t ulValue;
	uint32_t ulInfo;
 } __PACKED;

#ifdef WIN32
#pragma pack()
#endif // WIN32



/** <p>Read measured value on all modules.</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[out] <b><VAR>ulValues</VAR></b> : Array that contain the measured values, as raw or converted in the selected format.
*                                            <ul>
*                                               <li> ulValues [0] : Module 0 value
*                                               <li> ulValues [1] : Module 1 value
*                                               <li> ulValues [2] : Module 2 value
*                                               <li> ulValues [3] : Module 3 value
*                                            </ul></p>
*
* <p>@param[out] <b><VAR>ulMeasureErrors</VAR></b> : Array that contain the measure errors.
*     <ul>
*        <li> <p>ulMeasureErrors[0] : Module 0
*          <ul>
*             <li> 0 : No error.
*             <li> 1 : Amplitude error.
*             <li> 2 : Frequency error (in fast mode is this error not relevant).
*             <li> 3 : Amplitude and frequency error.
*          </ul></p>
*        <li> <p>ulMeasureErrors[1] : Module 1
*          <ul>
*             <li> 0 : No error.
*             <li> 1 : Amplitude error.
*             <li> 2 : Frequency error (in fast mode is this error not relevant).
*             <li> 3 : Amplitude and frequency error.
*          </ul></p>
*        <li> <p>ulMeasureErrors[2] : Module 2
*          <ul>
*             <li> 0 : No error.
*             <li> 1 : Amplitude error.
*             <li> 2 : Frequency error (in fast mode is this error not relevant).
*             <li> 3 : Amplitude and frequency error.
*          </ul></p>
*        <li> <p>ulMeasureErrors[3] : Module 3
*          <ul>
*             <li> 0 : No error.
*             <li> 1 : Amplitude error.
*             <li> 2 : Frequency error (in fast mode is this error not relevant).
*             <li> 3 : Amplitude and frequency error.
*          </ul></p>
*     </ul></p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -2 : Multifunction sub module index selection error.
*                       <li> -3 : Multifunction sub module is not a SinCos module.
*                       <li> -4 : Sinus / Cosinus module not initialised
*                       <li> -100 : Read Sinus Cosinus kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		    


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE17xx__MFSinCosReadAll(struct modbus * modbus,struct MSXE17xx__MFSinCosReadAll_parameters_t * Response);



/** <p>Read measured value on the module 0.</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[out] <b><VAR>ulValue</VAR></b> : Measured value, as raw or converted in the selected format.</p>
*
* <p>@param[out] <b><VAR>ulMeasureError:</VAR></b> : Measure error.\n
*     <ul>
*                               <li> 0 : No error.
*                               <li> 1 : Amplitude error.
*                               <li> 2 : Frequency error (in fast mode is this error not relevant).
*                               <li> 3 : Amplitude and frequency error.
*     </ul></p>
* </ul>
*
* <ul>
*
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -2 : Multifunction sub module index selection error.
*                       <li> -3 : Multifunction sub module is not a SinCos module.
*                       <li> -4 : Sinus / Cosinus module not initialised
*                       <li> -100 : Read Sinus Cosinus kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		    


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE17xx__MFSinCosRead0(struct modbus * modbus,struct MSXE17xx__MFSinCosRead0_parameters_t * Response);



/** <p>Read measured value on the module 1.</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[out] <b><VAR>ulValue</VAR></b> : Measured value, as raw or converted in the selected format.</p>
*
* <p>@param[out] <b><VAR>ulMeasureError</VAR></b> : Measure error.\n
*     <ul>
*                               <li> 0 : No error.
*                               <li> 1 : Amplitude error.
*                               <li> 2 : Frequency error (in fast mode is this error not relevant).
*                               <li> 3 : Amplitude and frequency error.
*     </ul></p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -2 : Multifunction sub module index selection error.
*                       <li> -3 : Multifunction sub module is not a SinCos module.
*                       <li> -4 : Sinus / Cosinus module not initialised
*                       <li> -100 : Read Sinus Cosinus kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		    


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE17xx__MFSinCosRead1(struct modbus * modbus,struct MSXE17xx__MFSinCosRead1_parameters_t * Response);



/** <p>Read measured value on the module 2.</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[out] <b><VAR>ulValue</VAR></b> : Measured value, as raw or converted in the selected format.</p>
*
* <p>@param[out] <b><VAR>ulMeasureError</VAR></b> : Measure error.\n
*     <ul>
*                               <li> 0 : No error.
*                               <li> 1 : Amplitude error.
*                               <li> 2 : Frequency error (in fast mode is this error not relevant).
*                               <li> 3 : Amplitude and frequency error.
*     </ul></p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -2 : Multifunction sub module index selection error.
*                       <li> -3 : Multifunction sub module is not a SinCos module.
*                       <li> -4 : Sinus / Cosinus module not initialised
*                       <li> -100 : Read Sinus Cosinus kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		    


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE17xx__MFSinCosRead2(struct modbus * modbus,struct MSXE17xx__MFSinCosRead2_parameters_t * Response);



/** <p>Read measured value on the module 3.</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[out] <b><VAR>ulValue</VAR></b> : Measured value, as raw or converted in the selected format.</p>
*
* <p>@param[out] <b><VAR>ulMeasureError</VAR></b> : Measure error.\n
*     <ul>
*                               <li> 0 : No error.
*                               <li> 1 : Amplitude error.
*                               <li> 2 : Frequency error (in fast mode is this error not relevant).
*                               <li> 3 : Amplitude and frequency error.
*     </ul></p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -2 : Multifunction sub module index selection error.
*                       <li> -3 : Multifunction sub module is not a SinCos module.
*                       <li> -4 : Sinus / Cosinus module not initialised
*                       <li> -100 : Read Sinus Cosinus kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		    


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE17xx__MFSinCosRead3(struct modbus * modbus,struct MSXE17xx__MFSinCosRead3_parameters_t * Response);



/** <p>Read measured value and abosolut position on the module 0.</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[out] <b><VAR>ulValue</VAR></b> : Measured value, as raw or converted in the selected format.</p>
* <p>@param[out] <b><VAR>ulAbsPos</VAR></b> : Measured absolut position value, as raw or converted in the selected format and only if ulAbsPosStatus = 1.</p>
* <p>@param[out] <b><VAR>ulAbsPosStatus</VAR></b> : 0 if absolut position not available. 1 if absolut position available</p>
*
* <p>@param[out] <b><VAR>ulMeasureError:</VAR></b> : Measure error.\n
*     <ul>
*                               <li> 0 : No error.
*                               <li> 1 : Amplitude error.
*                               <li> 2 : Frequency error (in fast mode is this error not relevant).
*                               <li> 3 : Amplitude and frequency error.
*     </ul></p>
* </ul>
*
* <ul>
*
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -2 : Multifunction sub module index selection error.
*                       <li> -3 : Multifunction sub module is not a SinCos module.
*                       <li> -4 : Sinus / Cosinus module not initialised
*                       <li> -100 : Read Sinus Cosinus kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		    


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE17xx__MFSinCosReadAbsPos0(struct modbus * modbus,struct MSXE17xx__MFSinCosReadAbsPos0_parameters_t * Response);



/** <p>Read measured value and abosolut position on the module 1.</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[out] <b><VAR>ulValue</VAR></b> : Measured value, as raw or converted in the selected format.</p>
* <p>@param[out] <b><VAR>ulAbsPos</VAR></b> : Measured absolut position value, as raw or converted in the selected format and only if ulAbsPosStatus = 1.</p>
* <p>@param[out] <b><VAR>ulAbsPosStatus</VAR></b> : 0 if absolut position not available. 1 if absolut position available</p>
*
* <p>@param[out] <b><VAR>ulMeasureError:</VAR></b> : Measure error.\n
*     <ul>
*                               <li> 0 : No error.
*                               <li> 1 : Amplitude error.
*                               <li> 2 : Frequency error (in fast mode is this error not relevant).
*                               <li> 3 : Amplitude and frequency error.
*     </ul></p>
* </ul>
*
* <ul>
*
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -2 : Multifunction sub module index selection error.
*                       <li> -3 : Multifunction sub module is not a SinCos module.
*                       <li> -4 : Sinus / Cosinus module not initialised
*                       <li> -100 : Read Sinus Cosinus kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		    


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE17xx__MFSinCosReadAbsPos1(struct modbus * modbus,struct MSXE17xx__MFSinCosReadAbsPos1_parameters_t * Response);



/** <p>Read measured value and abosolut position on the module 2.</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[out] <b><VAR>ulValue</VAR></b> : Measured value, as raw or converted in the selected format.</p>
* <p>@param[out] <b><VAR>ulAbsPos</VAR></b> : Measured absolut position value, as raw or converted in the selected format and only if ulAbsPosStatus = 1.</p>
* <p>@param[out] <b><VAR>ulAbsPosStatus</VAR></b> : 0 if absolut position not available. 1 if absolut position available</p>
*
* <p>@param[out] <b><VAR>ulMeasureError:</VAR></b> : Measure error.\n
*     <ul>
*                               <li> 0 : No error.
*                               <li> 1 : Amplitude error.
*                               <li> 2 : Frequency error (in fast mode is this error not relevant).
*                               <li> 3 : Amplitude and frequency error.
*     </ul></p>
* </ul>
*
* <ul>
*
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -2 : Multifunction sub module index selection error.
*                       <li> -3 : Multifunction sub module is not a SinCos module.
*                       <li> -4 : Sinus / Cosinus module not initialised
*                       <li> -100 : Read Sinus Cosinus kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		    


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE17xx__MFSinCosReadAbsPos2(struct modbus * modbus,struct MSXE17xx__MFSinCosReadAbsPos2_parameters_t * Response);



/** <p>Read measured value and abosolut position on the module 3.</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[out] <b><VAR>ulValue</VAR></b> : Measured value, as raw or converted in the selected format.</p>
* <p>@param[out] <b><VAR>ulAbsPos</VAR></b> : Measured absolut position value, as raw or converted in the selected format and only if ulAbsPosStatus = 1.</p>
* <p>@param[out] <b><VAR>ulAbsPosStatus</VAR></b> : 0 if absolut position not available. 1 if absolut position available</p>
*
* <p>@param[out] <b><VAR>ulMeasureError:</VAR></b> : Measure error.\n
*     <ul>
*                               <li> 0 : No error.
*                               <li> 1 : Amplitude error.
*                               <li> 2 : Frequency error (in fast mode is this error not relevant).
*                               <li> 3 : Amplitude and frequency error.
*     </ul></p>
* </ul>
*
* <ul>
*
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -2 : Multifunction sub module index selection error.
*                       <li> -3 : Multifunction sub module is not a SinCos module.
*                       <li> -4 : Sinus / Cosinus module not initialised
*                       <li> -100 : Read Sinus Cosinus kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		    


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE17xx__MFSinCosReadAbsPos3(struct modbus * modbus,struct MSXE17xx__MFSinCosReadAbsPos3_parameters_t * Response);



/** <p>Read measured value and abosolut position on the all the modules </p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[out] <b><VAR>ulValues</VAR></b> : Array that contain the measured values, as raw or converted in the selected format.
*                                            <ul>
*                                               <li> ulValues [0] : Module 0 value
*                                               <li> ulValues [1] : Module 1 value
*                                               <li> ulValues [2] : Module 2 value
*                                               <li> ulValues [3] : Module 3 value
*                                            </ul></p>
*
* <p>@param[out] <b><VAR>ulAbsPos</VAR></b> : Array that contain measured absolut position value, as raw or converted in the selected format and only if ulAbsPosStatus = 1.
*                                            <ul>
*                                               <li> ulAbsPos [0] : Module 0 absolut position value
*                                               <li> ulAbsPos [1] : Module 1 absolut position value
*                                               <li> ulAbsPos [2] : Module 2 absolut position value
*                                               <li> ulAbsPos [3] : Module 3 absolut position value
*                                            </ul></p>
* <p>@param[out] <b><VAR>ulAbsPosStatus</VAR></b> :Array that contain measured absolut position status
*     <ul>
*        <li> <p>ulAbsPosStatus[0] : Module 0
*          <ul>
*             <li> 0 : Absolut position not available.
*             <li> 1 : Absolut position available
*          </ul></p>
*        <li> <p>ulAbsPosStatus[1] : Module 1
*          <ul>
*             <li> 0 : Absolut position not available.
*             <li> 1 : Absolut position available
*          </ul></p>
*        <li> <p>ulAbsPosStatus[2] : Module 2
*          <ul>
*             <li> 0 : Absolut position not available.
*             <li> 1 : Absolut position available
*          </ul></p>
*        <li> <p>ulAbsPosStatus[3] : Module 3
*          <ul>
*             <li> 0 : Absolut position not available.
*             <li> 1 : Absolut position available
*          </ul></p>
*     </ul></p>
*
* <p>@param[out] <b><VAR>ulMeasureErrors</VAR></b> : Array that contain the measure errors.
*     <ul>
*        <li> <p>ulMeasureErrors[0] : Module 0
*          <ul>
*             <li> 0 : No error.
*             <li> 1 : Amplitude error.
*             <li> 2 : Frequency error (in fast mode is this error not relevant).
*             <li> 3 : Amplitude and frequency error.
*          </ul></p>
*        <li> <p>ulMeasureErrors[1] : Module 1
*          <ul>
*             <li> 0 : No error.
*             <li> 1 : Amplitude error.
*             <li> 2 : Frequency error (in fast mode is this error not relevant).
*             <li> 3 : Amplitude and frequency error.
*          </ul></p>
*        <li> <p>ulMeasureErrors[2] : Module 2
*          <ul>
*             <li> 0 : No error.
*             <li> 1 : Amplitude error.
*             <li> 2 : Frequency error (in fast mode is this error not relevant).
*             <li> 3 : Amplitude and frequency error.
*          </ul></p>
*        <li> <p>ulMeasureErrors[3] : Module 3
*          <ul>
*             <li> 0 : No error.
*             <li> 1 : Amplitude error.
*             <li> 2 : Frequency error (in fast mode is this error not relevant).
*             <li> 3 : Amplitude and frequency error.
*          </ul></p>
*     </ul></p>
* </ul>
*
* <ul>
*
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -2 : Multifunction sub module index selection error.
*                       <li> -3 : Multifunction sub module is not a SinCos module.
*                       <li> -4 : Sinus / Cosinus module not initialised
*                       <li> -100 : Read Sinus Cosinus kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		    


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE17xx__MFSinCosReadAbsPosAll(struct modbus * modbus,struct MSXE17xx__MFSinCosReadAbsPosAll_parameters_t * Response);



/** <p>Read all the digital I/O channel value. If channel is configured as output, then this function return the status of the output</p>
*
* <p><b>Parameters:</b></p>
*
* <ul>
* <p>@param[out]<b><VAR>ulChannelsValue</VAR></b> : Channels value</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : Means an system error occured
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE17xx__DigitalIOReadAllChannelsValue(struct modbus * modbus,struct MSXE17xx__DigitalIOReadAllChannelsValue_parameters_t * Response);



/** <pTest short circuit status</p>
*
* <p><b>Parameters:</b></p>
*
* <ul>
* <p>@param[out]<b><VAR>ulValue</VAR></b> : short circuit status: from 0 to 0xffff, one bit for each output
*          <ul>
*             <li> 0 : no short circuit
*             <li> 1 : short circuit
*          </ul></p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : Means an system error occured
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE17xx__DigitalIOTestShortCircuit(struct modbus * modbus,struct MSXE17xx__DigitalIOTestShortCircuit_parameters_t * Response);



/** <p> Get watchdog current status and value information</p>
*
* <p><b>Parameters:</b></p>
*
* <ul>
* <p>@param[out]<b><VAR>ulStatus</VAR></b> : Channels value
*    <ul>
*           <li> BIN XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXX0: is stopped
*           <li> BIN XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXX1: is running
*           <li> BIN XXXXXXXX XXXXXXXX XXXXXXXX XXXXXX0X: is not run down
*           <li> BIN XXXXXXXX XXXXXXXX XXXXXXXX XXXXXX1X: is run down
*    </ul></p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : Means an system error occured
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE17xx__IOWatchdogGetStatusAndValue(struct modbus * modbus,struct MSXE17xx__IOWatchdogGetStatusAndValue_parameters_t * Response);


/* Symbolic names for register */
enum {
MSXE17XX__MFCOMMONSETINPUTSFILTER=6000,
MSXE17XX__MFCOMMONREFERENCEVOLTAGEACTIVATION=6050,
MSXE17XX__MFCOMMONSETFIFO0LEVEL=6100,
MSXE17XX__MFCOMMONENABLEDISABLETRIGGERGATE=6150,
MSXE17XX__MFSINCOSINIT=1250,
MSXE17XX__MFSINCOSCLEAR=1300,
MSXE17XX__MFSINCOSRELEASE=1350,
MSXE17XX__MFSINCOSINITANDENABLELATCH=1400,
MSXE17XX__MFSINCOSDISABLEANDRELEASELATCH=1450,
MSXE17XX__MFSINCOSINITANDENABLECLEAR=1500,
MSXE17XX__MFSINCOSDISABLEANDRELEASECLEAR=1550,
MSXE17XX__MFSINCOSINITANDENABLECOMPARELOGIC=1600,
MSXE17XX__MFSINCOSDISABLEANDRELEASECOMPARELOGIC=1650,
MSXE17XX__MFSINCOSINITHARDWARETRIGGER=1700,
MSXE17XX__MFSINCOSRELEASEHARDWARETRIGGER=1750,
MSXE17XX__MFSINCOSINITINDEX=1800,
MSXE17XX__MFSINCOSRELEASEINDEX=1850,
MSXE17XX__MFSINCOSINITABSPOS=1900,
MSXE17XX__DIGITALIOWRITEALLCHANNELSVALUE=7100,
MSXE17XX__DIGITALIOREARMSHORTCIRCUIT=7150,
MSXE17XX__DIGITALIOINITPORT=7200,
MSXE17XX__IOWATCHDOGINITANDSTART=8050,
MSXE17XX__IOWATCHDOGSTOPANDRELEASE=8100,
};

#ifdef WIN32
#pragma pack(1)
#endif // WIN32

struct MSXE17xx__MFCommonSetInputsFilter_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulInputAFilterValue;
	uint32_t ulInputBFilterValue;
	uint32_t ulInputCFilterValue;
	uint32_t ulInputDFilterValue;
 } __PACKED;

struct MSXE17xx__MFCommonReferenceVoltageActivation_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulActivationFlag;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE17xx__MFCommonSetFIFO0Level_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulFIFOLevel;
	uint32_t ulTimeOutTimeBase;
	uint32_t ulReloadValue;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE17xx__MFCommonEnableDisableTriggerGate_parameters_t
{
	uint32_t ulTriggerConfiguration;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE17xx__MFSinCosInit_parameters_t
{
	uint32_t ulModuleIndex;
	uint32_t ulMode;
	uint32_t ulSignalPeriod;
	uint32_t ulResolution;
	uint32_t ulValueFormat;
	uint32_t ulOption01;
	uint32_t ulOption02;
	uint32_t ulOption03;
	uint32_t ulOption04;
 } __PACKED;

struct MSXE17xx__MFSinCosClear_parameters_t
{
	uint32_t ulModuleIndex;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE17xx__MFSinCosRelease_parameters_t
{
	uint32_t ulModuleIndex;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE17xx__MFSinCosInitAndEnableLatch_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulLatchSource;
	uint32_t ulCondition;
	uint32_t ulAutoMode;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE17xx__MFSinCosDisableAndReleaseLatch_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulLatchSource;
	uint32_t ulOption01;
 } __PACKED;

struct MSXE17xx__MFSinCosInitAndEnableClear_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulClearSource;
	uint32_t ulCondition;
	uint32_t ulAutoMode;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE17xx__MFSinCosDisableAndReleaseClear_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulClearSource;
	uint32_t ulOption01;
 } __PACKED;

struct MSXE17xx__MFSinCosInitAndEnableCompareLogic_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulValueLow;
	uint32_t ulValueHigh;
	uint32_t ulMode;
	uint32_t ulSynchroTrigger;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE17xx__MFSinCosDisableAndReleaseCompareLogic_parameters_t
{
	uint32_t ulMFModuleIndex;
 } __PACKED;

struct MSXE17xx__MFSinCosInitHardwareTrigger_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulEdgeSelection;
	uint32_t ulCount;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE17xx__MFSinCosReleaseHardwareTrigger_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulOption01;
 } __PACKED;

struct MSXE17xx__MFSinCosInitIndex_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulEdgeSelection;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE17xx__MFSinCosReleaseIndex_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulOption01;
 } __PACKED;

struct MSXE17xx__MFSinCosInitAbsPos_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulSignalPeriod;
	uint32_t ulNominalIncrement;
	uint32_t ulResolution;
	uint32_t ulValueFormat;
	uint32_t ulInvert;
	uint32_t ulOption01;
	uint32_t ulOption02;
	uint32_t ulOption03;
	uint32_t ulOption04;
 } __PACKED;

struct MSXE17xx__DigitalIOWriteAllChannelsValue_parameters_t
{
	uint32_t ulValue;
 } __PACKED;

struct MSXE17xx__DigitalIORearmShortCircuit_parameters_t
{
	uint32_t ulOption;
 } __PACKED;

struct MSXE17xx__DigitalIOInitPort_parameters_t
{
	uint32_t ulPort;
	uint32_t ulPortConfiguration;
 } __PACKED;

struct MSXE17xx__IOWatchdogInitAndStart_parameters_t
{
	uint32_t ulTimeBase;
	uint32_t ulTimeValue;
	uint32_t ulOption1;
	uint32_t ulOption2;
 } __PACKED;

struct MSXE17xx__IOWatchdogStopAndRelease_parameters_t
{
	uint32_t ulOption;
 } __PACKED;

#ifdef WIN32
#pragma pack()
#endif // WIN32


/** <p>Set a filter to the input of a multifunction sub module.</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3)</p>
* <p>@param[in] <b><VAR>ulInputAFilterValue</VAR></b> : Filter value for input A (0 to 262143).
*    <ul>
*                             <li> 0: Filter nicht benutzt
*                             <li> 1: 100 ns
*                             <li> 2: 200 ns
*                             <li> 3: 300 ns ...
*                             <li> 262143 : 26,2143 ms
*    </ul>
* </p>
* <p>@param[in] <b><VAR>ulInputBFilterValue</VAR></b> : Filter value for input B (0 to 262143).
*    <ul>
*                             <li> 0: Filter nicht benutzt
*                             <li> 1: 100 ns
*                             <li> 2: 200 ns
*                             <li> 3: 300 ns ...
*                             <li> 262143 : 26,2143 ms
*    </ul>
* </p>
* <p>@param[in] <b><VAR>ulInputCFilterValue</VAR></b> : Filter value for input C (0 to 262143).
*    <ul>
*                             <li> 0: Filter nicht benutzt
*                             <li> 1: 100 ns
*                             <li> 2: 200 ns
*                             <li> 3: 300 ns ...
*                             <li> 262143 : 26,2143 ms
*    </ul>
* </p>
* <p>@param[in] <b><VAR>ulInputDFilterValue</VAR></b> : Filter value for input D (0 to 262143).
*    <ul>
*                             <li> 0: Filter nicht benutzt
*                             <li> 1: 100 ns
*                             <li> 2: 200 ns
*                             <li> 3: 300 ns ...
*                             <li> 262143 : 26,2143 ms
*    </ul>
* </p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : Means an system error occured
*                       <li> -2 : Multifunction sub module index selection error
*                       <li> -3 : Input A filter value selection error
*                       <li> -4 : Input B filter value selection error
*                       <li> -5 : Input C filter value selection error
*                       <li> -6 : Input D filter value selection error
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFCommonSetInputsFilter(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulInputAFilterValue;
	uint32_t ulInputBFilterValue;
	uint32_t ulInputCFilterValue;
	uint32_t ulInputDFilterValue;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFCommonSetInputsFilter(modbus,ulMFModuleIndex,ulInputAFilterValue,ulInputBFilterValue,ulInputCFilterValue,ulInputDFilterValue,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFCommonSetInputsFilter");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFCommonSetInputsFilter\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFCommonSetInputsFilter()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFCommonSetInputsFilter OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFCommonSetInputsFilter(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulInputAFilterValue,
	uint32_t ulInputBFilterValue,
	uint32_t ulInputCFilterValue,
	uint32_t ulInputDFilterValue
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Permit to activate the reference voltage to pin D-</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3)</p>
* <p>@param[in] <b><VAR>ulActivationFlag</VAR></b> : Filter value for input A (0 to 262143).
*    <ul>
*                             <li> 0: normal mode from D- (Default mode)
*                             <li> 1: activate the reference voltage to pin D-
*    </ul>
* </p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : Reserved. Set it to 0.</p>
* <p>@param[in] <b><VAR>ulOption02</VAR></b> : Reserved. Set it to 0.</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : Means an system error occured
*                       <li> -2 : Multifunction sub module index selection error \n
*                       <li> -3 : Activation flag selection error \n
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFCommonReferenceVoltageActivation(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulActivationFlag;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFCommonReferenceVoltageActivation(modbus,ulMFModuleIndex,ulActivationFlag,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFCommonReferenceVoltageActivation");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFCommonReferenceVoltageActivation\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFCommonReferenceVoltageActivation()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFCommonReferenceVoltageActivation OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFCommonReferenceVoltageActivation(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulActivationFlag,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Define the number of data bloc in the first FIFO before transmit the datas</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3)</p>
* <p>@param[in] <b><VAR>ulFIFOLevel</VAR></b> : Define the FIFO level (1 to 200).</p>
* <p>@param[in] <b><VAR>ulTimeOutTimeBase</VAR></b> : Define a Time out : permit to receive the data from the FIFO before the FIFO level is reached.\n
*                                                     Time base of the timer (0: disabled, 1 for us, 2 for ms, 3 for s)</p>
* <p>@param[in] <b><VAR>ulReloadValue</VAR></b> : Time out reload value (1 to 0xFFFF)</p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : Reserved. Set it to 0.</p>
* <p>@param[in] <b><VAR>ulOption02</VAR></b> : Reserved. Set it to 0.</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : Means an system error occured
*                       <li> -2 : Multifunction sub module index selection error
*                       <li> -3 : FIFO level value is wrong
*                       <li> -4 : Time out time base selection error
*                       <li> -5 : Time out value can not be null, if a time base is selected
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFCommonSetFIFO0Level(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulFIFOLevel;
	uint32_t ulTimeOutTimeBase;
	uint32_t ulReloadValue;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFCommonSetFIFO0Level(modbus,ulMFModuleIndex,ulFIFOLevel,ulTimeOutTimeBase,ulReloadValue,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFCommonSetFIFO0Level");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFCommonSetFIFO0Level\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFCommonSetFIFO0Level()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFCommonSetFIFO0Level OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFCommonSetFIFO0Level(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulFIFOLevel,
	uint32_t ulTimeOutTimeBase,
	uint32_t ulReloadValue,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Define the number of data bloc in the first FIFO before transmit the datas</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulTriggerConfiguration</VAR></b> : Trigger configuration:</p>
*    <ul>
*                             <li> Bit 0: Hardware trigger</li>
*                             <ul>
*                                 <li> 0 : Disable hardware trigger gate</li>
*                                 <li> 1 : Enable hardware trigger gate</li>
*                             </ul>
*    </ul>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : Reserved. Set it to 0.</p>
* <p>@param[in] <b><VAR>ulOption02</VAR></b> : Reserved. Set it to 0.</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : Means an system error occured
*                       <li> -2 : ulTriggerConfiguration parameter is wrong
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFCommonEnableDisableTriggerGate(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulTriggerConfiguration;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFCommonEnableDisableTriggerGate(modbus,ulTriggerConfiguration,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFCommonEnableDisableTriggerGate");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFCommonEnableDisableTriggerGate\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFCommonEnableDisableTriggerGate()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFCommonEnableDisableTriggerGate OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFCommonEnableDisableTriggerGate(struct modbus * modbus,
	uint32_t ulTriggerConfiguration,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Initialize the selected Sinus / Cosinus module.</p>
*
* <p><b>Parameters:</b></p>
*
* <ul>
* <p>@param[in] <b><VAR>ulModuleIndex</VAR></b> : The module to initialize (0 to 3).</p>
* <p>@param[in] <b><VAR>ulMode</VAR></b> : Measure mode\n
*     <ul>
*                    <li> 0 : Fast measure. The measure is fast,\n
*                         always 250 kHz but the measure range is smaller.
*                    <li> 1 : Full range. The measure is slow but the maximal range is used.\n
*                         See in the table called\n
*                         "Max. input frequency in corresponding with the input ulResolution"\n
*                         in order to set the measure frequency.
*     </ul></p>
* <p>@param[in] <b><VAR>ulSignalPeriod</VAR></b> : Signal period.</p>
* <p>@param[in] <b><VAR>ulResolution</VAR></b> : Reslution to use for the measure (binary value)</p>
*
* <p>
  <b>Max. input frequency in corresponding with the input ulResolution:</b><br>
  <table border="1">
     <tr>
        <td> Resolution </td>
        <td> Max. Freq. Hz </td>
        <td> Compatible with </td>
     </tr>
     <tr>
        <td> 16 </td>
        <td> 250000 </td>
        <td> fast mode and full range mode  </td>
     </tr>
     <tr>
        <td> 25 </td>
        <td> 26000 </td>
        <td> fast mode  </td>
     </tr>
     <tr>
        <td> 32 </td>
        <td> 162500 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 40 </td>
        <td> 16300 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 50 </td>
        <td> 26000 </td>
        <td> fast mode  </td>
     </tr>
     <tr>
        <td> 64 </td>
        <td> 81300 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 80 </td>
        <td> 16300 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 100 </td>
        <td> 26000 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 125 </td>
        <td> 20800 </td>
        <td> fast mode  </td>
     </tr>
     <tr>
        <td> 128 </td>
        <td> 40600 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 160 </td>
        <td> 16300 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 200 </td>
        <td> 26000 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 250 </td>
        <td> 20800 </td>
        <td> fast mode  </td>
     </tr>
     <tr>
        <td> 256 </td>
        <td> 20300 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 320 </td>
        <td> 16300 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 400 </td>
        <td> 13000 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 500 </td>
        <td> 10400 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 512 </td>
        <td> 10200 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 800 </td>
        <td> 6500 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 1000 </td>
        <td> 5200 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 1024 </td>
        <td> 5100 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 1600 </td>
        <td> 3300 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 2000 </td>
        <td> 2600 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 2048 </td>
        <td> 2540 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 4096 </td>
        <td> 1270 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 8192 </td>
        <td> 635 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
  </table>
</p>
*
* <p>@param[in] <b><VAR>ulValueFormat</VAR></b> : Output format of the measure\n
*     <ul>
*                           <li> 0 : Raw data.
*                           <li> 1 : Standardized in mm.
*     </ul></p>
*
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : Reserved. Set it to 0.</p>
* <p>@param[in] <b><VAR>ulOption02</VAR></b> : Reserved. Set it to 0.</p>
* <p>@param[in] <b><VAR>ulOption03</VAR></b> : Reserved. Set it to 0.</p>
* <p>@param[in] <b><VAR>ulOption04</VAR></b> : Reserved. Set it to 0.</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -2 : Multifunction sub module index selection error.
*                       <li> -3 : Multifunction sub module is not a SinCos module.
*                       <li> -4 : Wrong mode.
*                       <li> -5 : Wrong signal period.
*                       <li> -6 : Wrong resolution.
*                       <li> -7 : The resolution is not supported by the selected mode.
*                       <li> -8 : Wrong format.
*                       <li> -9 : Auto gain calibration error.
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFSinCosInit(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulModuleIndex;
	uint32_t ulMode;
	uint32_t ulSignalPeriod;
	uint32_t ulResolution;
	uint32_t ulValueFormat;
	uint32_t ulOption01;
	uint32_t ulOption02;
	uint32_t ulOption03;
	uint32_t ulOption04;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFSinCosInit(modbus,ulModuleIndex,ulMode,ulSignalPeriod,ulResolution,ulValueFormat,ulOption01,ulOption02,ulOption03,ulOption04,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFSinCosInit");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFSinCosInit\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFSinCosInit()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFSinCosInit OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFSinCosInit(struct modbus * modbus,
	uint32_t ulModuleIndex,
	uint32_t ulMode,
	uint32_t ulSignalPeriod,
	uint32_t ulResolution,
	uint32_t ulValueFormat,
	uint32_t ulOption01,
	uint32_t ulOption02,
	uint32_t ulOption03,
	uint32_t ulOption04
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Clear the selected Sinus / Cosinus module.</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulModuleIndex</VAR></b> : The module to clear (0 to 3).</p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : Reserved. Set to 0.</p>
* <p>@param[in] <b><VAR>ulOption02</VAR></b> : Reserved. Set to 0.</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -2 : Multifunction sub module index selection error.
*                       <li> -3 : Multifunction sub module is not a SinCos module.
*                       <li> -4 : Sinus / Cosinus module not initialised
*                       <li> -100 : Clear Sinus Cosinus kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFSinCosClear(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulModuleIndex;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFSinCosClear(modbus,ulModuleIndex,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFSinCosClear");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFSinCosClear\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFSinCosClear()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFSinCosClear OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFSinCosClear(struct modbus * modbus,
	uint32_t ulModuleIndex,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Release the selected Sinus / Cosinus module.</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulModuleIndex</VAR></b> : The module to clear (0 to 3).</p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : Reserved. Set to 0.</p>
* <p>@param[in] <b><VAR>ulOption02</VAR></b> : Reserved. Set to 0.</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -2 : Multifunction sub module index selection error.
*                       <li> -3 : Multifunction sub module is not a SinCos module.
*                       <li> -4 : Sinus / Cosinus module not initialised
*                       <li> -100 : Release Sinus Cosinus kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFSinCosRelease(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulModuleIndex;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFSinCosRelease(modbus,ulModuleIndex,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFSinCosRelease");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFSinCosRelease\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFSinCosRelease()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFSinCosRelease OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFSinCosRelease(struct modbus * modbus,
	uint32_t ulModuleIndex,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Init and enable a counter latch logic</p>
*
*<p>
For each latch the data server send a 5 DWORD frame with following informations:<br>
<ul>
  <li>DWORD 0 : Time stamp micro s
  <li>DWORD 1 : Time stamp s
  <li>DWORD 2 :
  <ul>
     <li>D1-D0   : Sub module index (0 to 3)
     <li>D31-D16 : Sub module functionality (2) 
  </ul>
  <li>DWORD 3 : Event mask
  <ul>
     <li><p>D30-D0 :<br>
        2: Hardware trigger latch occur <br>
        3: Synchro input latch occur <br>
        4: Index input latch occur</p>
     <li><p>D31 : <br>
        0: No error occur <br>
        1: Amplitude or Frequency error occur.</p>
  </ul>
  <li>DWORD 4 :
  <ul>
     <li>D31-D0: Counter value (DWORD) if the selected output format of the measure is raw data
     <li>D31-D0: Current position in mm (FLOAT) if the selected output format of the measure is standardized in mm.
  </ul>
</ul>
</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : Index of the multifunction sub module (0 to 3).</p>
* <p>@param[in] <b><VAR>ulLatchSource</VAR></b> : Latch source. \n
*     <ul>
*                            <li>  0: Index input
*                            <li>  1: Hardware trigger
*                            <li>  2: Synchro input
*     </ul></p>
* <p>@param[in] <b><VAR>ulCondition</VAR></b> : Previously condition for accept the latch source \n
*     <ul>
*                            <li>  0: No previously condition required
*                            <li>  1: Index input condition required (Only if index input not selected selected for the latch source)
*                            <li>  2: Hardware trigger condition required (Only if hardware trigger not selected selected for the latch source)
*                            <li>  3: Synchro input condition required (Only if synchro input not selected selected for the latch source)
*     </ul></p>
* <p>@param[in] <b><VAR>ulAutoMode</VAR></b> : Action mode \n
*     <ul>
*                            <li>  0: Do not use auto mode (action is done only once)
*                            <li>  1: Use auto mode (action is done continously)
*     </ul></p>
* <p>@param[in] <b><VAR>ulOption02</VAR></b> : set it to 0</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Multifunction sub module is not a SinCos module.
*                            <li> -4: Sinus / Cosinus module not initialised
*                            <li> -5: Latch logic already initialised
*                            <li> -6: Latch source selection error
*                            <li> -7: Previously condition selection error
*                            <li> -8: Auto mode selection error
*                            <li> -9: Hardware trigger not initialised. Refer to MSXE17xx__MFSinCosInitHardwareTrigger
*                            <li> -10: Index input not initialised. Refer to MSXE17xx__MFSinCosInitIndex
*                            <li> -11: Can not be used for the "fast measure" mode
*                            <li> -100: Init and enable counter latch kernel function error
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFSinCosInitAndEnableLatch(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulLatchSource;
	uint32_t ulCondition;
	uint32_t ulAutoMode;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFSinCosInitAndEnableLatch(modbus,ulMFModuleIndex,ulLatchSource,ulCondition,ulAutoMode,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFSinCosInitAndEnableLatch");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFSinCosInitAndEnableLatch\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFSinCosInitAndEnableLatch()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFSinCosInitAndEnableLatch OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFSinCosInitAndEnableLatch(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulLatchSource,
	uint32_t ulCondition,
	uint32_t ulAutoMode,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Disable and Release a counter latch logic</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3).</p>
* <p>@param[in] <b><VAR>ulLatchSource</VAR></b> : Latch source to disable and release.\n
*     <ul>
*                            <li>  0: Index input
*                            <li>  1: Hardware trigger
*                            <li>  2: Synchro input
*     </ul></p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : set it to 0</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Multifunction sub module is not a SinCos module.
*                            <li> -4: Sinus / Cosinus module not initialised
*                            <li> -5: Latch logic not initialised
*                            <li> -6: Latch source selection error
*                            <li> -100: Disable and release counter latch register kernel function error
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFSinCosDisableAndReleaseLatch(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulLatchSource;
	uint32_t ulOption01;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFSinCosDisableAndReleaseLatch(modbus,ulMFModuleIndex,ulLatchSource,ulOption01,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFSinCosDisableAndReleaseLatch");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFSinCosDisableAndReleaseLatch\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFSinCosDisableAndReleaseLatch()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFSinCosDisableAndReleaseLatch OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFSinCosDisableAndReleaseLatch(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulLatchSource,
	uint32_t ulOption01
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Init and enable a counter clear logic</p>
*
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : Index of the multifunction sub module (0 to 3).</p>
* <p>@param[in] <b><VAR>ulClearSource</VAR></b> : Clear source. \n
*     <ul>
*                            <li>  0: Index input
*                            <li>  1: Hardware trigger
*                            <li>  2: Synchro input
*     </ul></p>
* <p>@param[in] <b><VAR>ulCondition</VAR></b> : Previously condition for accept the clear source \n
*     <ul>
*                            <li>  0: No previously condition required
*                            <li>  1: Index input condition required (Only if index input not selected selected for the clear source)
*                            <li>  2: Hardware trigger condition required (Only if hardware trigger not selected selected for the clear source)
*                            <li>  3: Synchro input condition required (Only if synchro input not selected selected for the clear source)
*     </ul></p>
* <p>@param[in] <b><VAR>ulAutoMode</VAR></b> : Action mode \n
*     <ul>
*                            <li>  0: Do not use auto mode (action is done only once)
*                            <li>  1: Use auto mode (action is done continously)
*     </ul></p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : set it to 0</p>
* <p>@param[in] <b><VAR>ulOption02</VAR></b> : set it to 0</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Multifunction sub module is not a SinCos module.
*                            <li> -4: Sinus / Cosinus module not initialised
*                            <li> -5: Clear logic already initialised
*                            <li> -6: Clear source selection error
*                            <li> -7: Previously condition selection error
*                            <li> -8: Auto mode selection error
*                            <li> -9: Hardware trigger not initialised. Refer to MSXE17xx__MFSinCosInitHardwareTrigger
*                            <li> -10: Index input not initialised. Refer to MSXE17xx__MFSinCosInitIndex
*                            <li> -11: Can not be used for the "fast measure" mode
*                            <li> -100: Init and enable counter clear kernel function error
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFSinCosInitAndEnableClear(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulClearSource;
	uint32_t ulCondition;
	uint32_t ulAutoMode;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFSinCosInitAndEnableClear(modbus,ulMFModuleIndex,ulClearSource,ulCondition,ulAutoMode,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFSinCosInitAndEnableClear");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFSinCosInitAndEnableClear\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFSinCosInitAndEnableClear()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFSinCosInitAndEnableClear OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFSinCosInitAndEnableClear(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulClearSource,
	uint32_t ulCondition,
	uint32_t ulAutoMode,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Disable and Release a counter clear logic</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3).</p>
* <p>@param[in] <b><VAR>ulClearSource</VAR></b> : Clear source to disable and release. \n
*     <ul>
*                            <li>  0: Index input
*                            <li>  1: Hardware trigger
*                            <li>  2: Synchro input
*     </ul></p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : set it to 0</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Multifunction sub module is not a SinCos module.
*                            <li> -4: Sinus / Cosinus module not initialised
*                            <li> -5: Clear logic not initialised
*                            <li> -6: Clear source selection error
*                            <li> -100: Disable and release counter clear register kernel function error
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFSinCosDisableAndReleaseClear(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulClearSource;
	uint32_t ulOption01;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFSinCosDisableAndReleaseClear(modbus,ulMFModuleIndex,ulClearSource,ulOption01,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFSinCosDisableAndReleaseClear");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFSinCosDisableAndReleaseClear\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFSinCosDisableAndReleaseClear()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFSinCosDisableAndReleaseClear OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFSinCosDisableAndReleaseClear(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulClearSource,
	uint32_t ulOption01
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Init and enable a counter compare value</p>
*
*<p>
For each latch the data server send a 5 DWORD frame with following informations:<br>
<ul>
  <li>DWORD 0 : Time stamp micro s
  <li>DWORD 1 : Time stamp s
  <li>DWORD 2 :
  <ul>
     <li>D1-D0   : Sub module index (0 to 3)
     <li>D31-D16 : Sub module functionality (2) 
  </ul>
  <li>DWORD 3 : Event mask
  <ul>
     <li><p>D30-D0 :<br>
        0: Compare occur
     <li><p>D31 : <br>
        0: No error occur <br>
        1: Amplitude or Frequency error occur.</p>
  </ul>
  <li>DWORD 4 :
  <ul>
     <li>D31-D0: Counter value (DWORD) if the selected output format of the measure is raw data
     <li>D31-D0: Current position in mm (FLOAT) if the selected output format of the measure is standardized in mm.
  </ul>
</ul>
</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3).</p>
* <p>@param[in] <b><VAR>ulValueLow / ulValueLow</VAR></b> : compare value (double). ulValueLow : low 32-bit from double. ulValueHigh : high 32-bit from double \n
*     <ul>
*                                     <li> 0 to 0xFFFFFFFF if raw data seleced
*                                     <li> Position in mm if the measure is standardized in mm
*     </ul></p>
* <p>@param[in] <b><VAR>ulMode</VAR></b> : compare mode \n
*     <ul>
*                                     <li> 0: condition true when counter equals compare value
*                                     <li> 1: condition true when counter equals a multiple of the compare value
*     </ul></p>
* <p>@param[in] <b><VAR>ulSynchroTrigger</VAR></b> \n
*     <ul>
*                                     <li> 0 : no synchro trigger
*                                     <li> 1 : generates a synchro trigger when condition is true
*     </ul></p>
* <p>@param[in] <b><VAR>ulOption02</VAR></b> : set it to 0</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Compare value error
*                            <li> -4: Compare mode error
*                            <li> -5: Synchro trigger error
*                            <li> -6: Multifunction sub module is not a SinCos module.
*                            <li> -7: Sinus / Cosinus module not initialised
*                            <li> -8: Compare logic already initialised
*                            <li> -9: Can not be used for the "fast measure" mode
*                            <li> -100: Init and enable counter compare kernel function error
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFSinCosInitAndEnableCompareLogic(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulValueLow;
	uint32_t ulValueHigh;
	uint32_t ulMode;
	uint32_t ulSynchroTrigger;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFSinCosInitAndEnableCompareLogic(modbus,ulMFModuleIndex,ulValueLow,ulValueHigh,ulMode,ulSynchroTrigger,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFSinCosInitAndEnableCompareLogic");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFSinCosInitAndEnableCompareLogic\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFSinCosInitAndEnableCompareLogic()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFSinCosInitAndEnableCompareLogic OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFSinCosInitAndEnableCompareLogic(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulValueLow,
	uint32_t ulValueHigh,
	uint32_t ulMode,
	uint32_t ulSynchroTrigger,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Disable and Release a counter compare value</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3).</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Multifunction sub module is not a SinCos module.
*                            <li> -4: Sinus / Cosinus module not initialised
*                            <li> -5: Compare logic not initialised
*                            <li> -100: Disable counter compare value kernel function error
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFSinCosDisableAndReleaseCompareLogic(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFSinCosDisableAndReleaseCompareLogic(modbus,ulMFModuleIndex,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFSinCosDisableAndReleaseCompareLogic");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFSinCosDisableAndReleaseCompareLogic\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFSinCosDisableAndReleaseCompareLogic()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFSinCosDisableAndReleaseCompareLogic OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFSinCosDisableAndReleaseCompareLogic(struct modbus * modbus,
	uint32_t ulMFModuleIndex
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Init the hardware trigger configuration</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3).</p>
* <p>@param[in] <b><VAR>ulEdgeSelection</VAR></b> : Front selection \n
*     <ul>
*                                       <li> 01 : rising front
*                                       <li> 10 : falling front
*                                       <li> 11 : Both front
*     </ul></p>
* <p>@param[in] <b><VAR>ulCount</VAR></b> :Define the number of trigger events before the action occur \n
*     <ul>
*                                       <li> 1 : all trigger event start the action
*                                       <li> max value : 65535
*     </ul></p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : Hardware trigger gate
*     <ul>
*                                       <li> 0 : Don't use hardware trigger gate
*                                       <li> 1 : Use hardware trigger gate
*     </ul></p>
* <p>@param[in] <b><VAR>ulOption02 </VAR></b>: set it to 0</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Multifunction sub module is not a SinCos module.
*                            <li> -4: Trigger edge selection error
*                            <li> -5: Trigger count selection error
*                            <li> -6: Sinus / Cosinus module not initialised
*                            <li> -7: Hardware trigger already initialised
*                            <li> -100: Init hardware trigger kernel function error
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFSinCosInitHardwareTrigger(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulEdgeSelection;
	uint32_t ulCount;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFSinCosInitHardwareTrigger(modbus,ulMFModuleIndex,ulEdgeSelection,ulCount,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFSinCosInitHardwareTrigger");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFSinCosInitHardwareTrigger\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFSinCosInitHardwareTrigger()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFSinCosInitHardwareTrigger OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFSinCosInitHardwareTrigger(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulEdgeSelection,
	uint32_t ulCount,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Release the hardware trigger</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3).</p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : set it to 0</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Multifunction sub module is not a SinCos module.
*                            <li> -4: Sinus / Cosinus module not initialised
*                            <li> -5: Hardware trigger not initialised
*                            <li> -6: Hardware trigger used and can not released
*                            <li> -100: Release hardware trigger kernel function error
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFSinCosReleaseHardwareTrigger(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulOption01;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFSinCosReleaseHardwareTrigger(modbus,ulMFModuleIndex,ulOption01,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFSinCosReleaseHardwareTrigger");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFSinCosReleaseHardwareTrigger\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFSinCosReleaseHardwareTrigger()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFSinCosReleaseHardwareTrigger OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFSinCosReleaseHardwareTrigger(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulOption01
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Init the index configuration</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3).</p>
* <p>@param[in] <b><VAR>ulEdgeSelection</VAR></b> : Front selection
*     <ul>
*                                       <li> 01 : rising front
*                                       <li> 10 : falling front
*                                       <li> 11 : Both front
*     </ul></p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : set it to 0</p>
* <p>@param[in] <b><VAR>ulOption02 </VAR></b>: set it to 0</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Multifunction sub module is not a SinCos module.
*                            <li> -4: Index edge selection error
*                            <li> -5: Sinus / Cosinus module not initialised
*                            <li> -6: Index already initialised
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFSinCosInitIndex(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulEdgeSelection;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFSinCosInitIndex(modbus,ulMFModuleIndex,ulEdgeSelection,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFSinCosInitIndex");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFSinCosInitIndex\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFSinCosInitIndex()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFSinCosInitIndex OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFSinCosInitIndex(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulEdgeSelection,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Release the index</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3).</p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : set it to 0</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Multifunction sub module is not a SinCos module.
*                            <li> -4: Sinus / Cosinus module not initialised
*                            <li> -5: Index not initialised
*                            <li> -6: Index used and can not released
*                            <li> -100: Release Index kernel function error
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFSinCosReleaseIndex(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulOption01;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFSinCosReleaseIndex(modbus,ulMFModuleIndex,ulOption01,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFSinCosReleaseIndex");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFSinCosReleaseIndex\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFSinCosReleaseIndex()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFSinCosReleaseIndex OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFSinCosReleaseIndex(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulOption01
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Initialize the selected Sinus / Cosinus absolute position module.</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulModuleIndex</VAR></b> : The module to initialize (0 to 3).</p>
* <p>@param[in] <b><VAR>ulSignalPeriod</VAR></b> : Signal period.</p>
* <p>@param[in] <b><VAR>ulNominalIncrement</VAR></b> : Nominal incremenet in signal periods.</p>
* <p>@param[in] <b><VAR>ulResolution</VAR></b> : Reslution to use for the measure (binary value)</p>
*
* <p>
  <b>Max. input frequency in corresponding with the input ulResolution:</b><br>
  <table border="1">
     <tr>
        <td> Resolution </td>
        <td> Max. Freq. Hz </td>
        <td> Compatible with </td>
     </tr>
     <tr>
        <td> 16 </td>
        <td> 250000 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 25 </td>
        <td> 26000 </td>
        <td> fast mode  </td>
     </tr>
     <tr>
        <td> 32 </td>
        <td> 162500 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 40 </td>
        <td> 16300 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 50 </td>
        <td> 26000 </td>
        <td> fast mode  </td>
     </tr>
     <tr>
        <td> 64 </td>
        <td> 81300 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 80 </td>
        <td> 16300 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 100 </td>
        <td> 26000 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 125 </td>
        <td> 20800 </td>
        <td> fast mode  </td>
     </tr>
     <tr>
        <td> 128 </td>
        <td> 40600 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 160 </td>
        <td> 16300 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 200 </td>
        <td> 26000 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 250 </td>
        <td> 20800 </td>
        <td> fast mode  </td>
     </tr>
     <tr>
        <td> 256 </td>
        <td> 20300 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 320 </td>
        <td> 16300 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 400 </td>
        <td> 13000 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 500 </td>
        <td> 10400 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 512 </td>
        <td> 10200 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 800 </td>
        <td> 6500 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 1000 </td>
        <td> 5200 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 1024 </td>
        <td> 5100 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 1600 </td>
        <td> 3300 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 2000 </td>
        <td> 2600 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 2048 </td>
        <td> 2540 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 4096 </td>
        <td> 1270 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
        <td> 8192 </td>
        <td> 635 </td>
        <td> fast mode and full range mode </td>
     </tr>
     <tr>
  </table>
</p>
*
* <p>@param[in] <b><VAR>ulValueFormat</VAR></b> : Output format of the measure\n
*     <ul>
*                           <li> 0 : Raw data.
*                           <li> 1 : Standardized in mm.
*     </ul></p>
*
* <p>@param[in] <b><VAR>ulInvert</VAR></b> : Direction inversion\n
*     <ul>
*                           <li> 0 : No inversion.
*                           <li> 1 : Invert the direction.
*     </ul></p>
*
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : Reserved. Set it to 0.</p>
* <p>@param[in] <b><VAR>ulOption02</VAR></b> : Reserved. Set it to 0.</p>
* <p>@param[in] <b><VAR>ulOption03</VAR></b> : Reserved. Set it to 0.</p>
* <p>@param[in] <b><VAR>ulOption04</VAR></b> : Reserved. Set it to 0.</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -2 : Multifunction sub module index selection error.
*                       <li> -3 : Multifunction sub module is not a SinCos module.
*                       <li> -4 : Wrong nominal increment.
*                       <li> -5 : Wrong signal period.
*                       <li> -6 : Wrong resolution.
*                       <li> -7 : The resolution is not supported by the selected mode.
*                       <li> -8 : Wrong format.
*                       <li> -9 : Auto gain calibration error.
*                       <li> -10 : Index already initialised.
*                       <li> -11 : Enable latch initialisation error.
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFSinCosInitAbsPos(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulSignalPeriod;
	uint32_t ulNominalIncrement;
	uint32_t ulResolution;
	uint32_t ulValueFormat;
	uint32_t ulInvert;
	uint32_t ulOption01;
	uint32_t ulOption02;
	uint32_t ulOption03;
	uint32_t ulOption04;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFSinCosInitAbsPos(modbus,ulMFModuleIndex,ulSignalPeriod,ulNominalIncrement,ulResolution,ulValueFormat,ulInvert,ulOption01,ulOption02,ulOption03,ulOption04,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFSinCosInitAbsPos");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFSinCosInitAbsPos\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFSinCosInitAbsPos()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFSinCosInitAbsPos OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFSinCosInitAbsPos(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulSignalPeriod,
	uint32_t ulNominalIncrement,
	uint32_t ulResolution,
	uint32_t ulValueFormat,
	uint32_t ulInvert,
	uint32_t ulOption01,
	uint32_t ulOption02,
	uint32_t ulOption03,
	uint32_t ulOption04
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Write all digital i/o channels value. if the channel is define as input, nothing append on this channel.</p>
*
* <p><b>Parameters:</b></p>
*
* <ul>
* <p>@param[in]<b><VAR>ulValue</VAR></b> : Channels value</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -100: Write digital I/O kernel function error
*     </ul>
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__DigitalIOWriteAllChannelsValue(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulValue;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__DigitalIOWriteAllChannelsValue(modbus,ulValue,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__DigitalIOWriteAllChannelsValue");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__DigitalIOWriteAllChannelsValue\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__DigitalIOWriteAllChannelsValue()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__DigitalIOWriteAllChannelsValue OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__DigitalIOWriteAllChannelsValue(struct modbus * modbus,
	uint32_t ulValue
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Rearm digital outputs after a short circuit happened.</p>
*
* <p><b>Parameters:</b></p>
*
* <ul>
* <p>@param[in] <b><VAR>ulOption</VAR></b> : Reserved. Set to 0.</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__DigitalIORearmShortCircuit(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulOption;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__DigitalIORearmShortCircuit(modbus,ulOption,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__DigitalIORearmShortCircuit");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__DigitalIORearmShortCircuit\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__DigitalIORearmShortCircuit()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__DigitalIORearmShortCircuit OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__DigitalIORearmShortCircuit(struct modbus * modbus,
	uint32_t ulOption
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Initialise a digital i/o port (2 channels).</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulPort</VAR></b> : Index of the digital i/o port (0 to 7).</p>
* <p>@param[in] <b><VAR>ulPortConfiguration</VAR></b> : Define the port configuration
*    <ul>
*                             <li> 0 : input
*                             <li> 1 : output
*    </ul>
* </ul></p>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -2: Digital i/o port selection error
*                       <li> -3: Port configuration selection error
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__DigitalIOInitPort(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulPort;
	uint32_t ulPortConfiguration;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__DigitalIOInitPort(modbus,ulPort,ulPortConfiguration,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__DigitalIOInitPort");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__DigitalIOInitPort\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__DigitalIOInitPort()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__DigitalIOInitPort OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__DigitalIOInitPort(struct modbus * modbus,
	uint32_t ulPort,
	uint32_t ulPortConfiguration
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Init and start the digital output IO watchdog.</p>
*
* <p><b>Parameters:</b></p>
*
* <ul>
* <p>@param[in] <b><VAR>ulTimeBase</VAR></b> : Time base of the watchdog delay (0 for mus, 1 for ms, 2 for s)</p>
* <p>@param[in] <b><VAR>ulTimeValue</VAR></b> : Time base of the watchdog delay (0 to 0xFFFF).</p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : Reserved. Set to 0.</p>
* <p>@param[in] <b><VAR>ulOption02</VAR></b> : Reserved. Set to 0.</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : Means an system error occured
*                       <li> -2:: Time base selection error
*                       <li> -3:: Time value selection error
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__IOWatchdogInitAndStart(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulTimeBase;
	uint32_t ulTimeValue;
	uint32_t ulOption1;
	uint32_t ulOption2;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__IOWatchdogInitAndStart(modbus,ulTimeBase,ulTimeValue,ulOption1,ulOption2,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__IOWatchdogInitAndStart");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__IOWatchdogInitAndStart\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__IOWatchdogInitAndStart()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__IOWatchdogInitAndStart OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__IOWatchdogInitAndStart(struct modbus * modbus,
	uint32_t ulTimeBase,
	uint32_t ulTimeValue,
	uint32_t ulOption1,
	uint32_t ulOption2
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Stop and release the digital output watchdog.</p>
*
* <p><b>Parameters:</b></p>
*
* <ul>
* <p>@param[in] <b><VAR>ulOption</VAR></b> : Reserved. Set to 0.</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : Means an system error occured
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__IOWatchdogStopAndRelease(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulOption;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__IOWatchdogStopAndRelease(modbus,ulOption,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__IOWatchdogStopAndRelease");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__IOWatchdogStopAndRelease\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__IOWatchdogStopAndRelease()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__IOWatchdogStopAndRelease OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__IOWatchdogStopAndRelease(struct modbus * modbus,
	uint32_t ulOption
, struct GetLastCommandStatus_parameters_t * CommandStatus);

#endif //_MODBUS_MSXE171X_CLIENT_DEFINITION_H_


