using System;
using System.Threading;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.Net.Sockets;
using AddiData.ADDISocket;

namespace CyclicAcquisition
{
	/// <summary>
	/// Zusammenfassung fr CyclicAcquisition.
	/// </summary>
	public class CyclicAcquisition : System.Windows.Forms.Form
    {
        private System.Windows.Forms.GroupBox groupBox2;
        private System.Windows.Forms.Label label1;
        private GroupBox GB_CounterConfig;
        private Label L_IC_Label1;
        private ComboBox LB_SC_ValueFormat;
        private CheckBox CH_Counter3;
        private CheckBox CH_Counter2;
        private CheckBox CH_Counter1;
        private CheckBox CH_Counter0;
        private Label label2;
        private GroupBox GB_Help;
        private Label L_Help;
        private GroupBox GB_Acquisition;
        private TextBox TB_TransferNbr;
        private Label label8;
        private TextBox TB_SequenceNbr;
        private Label label7;
        private Label label11;
        private Label label10;
        private ComboBox LB_ReadTime;
        private TextBox TB_TimeValue;
        private Button B_CounterInitialisation;
        private Button B_ClearCounter;
        private Button B_StartCounterAcquisition;
        private Button B_StopCounterAcquisition;
        private Button B_CounterReleaseInitialisation;
        private GroupBox GB_AcquisitionInfo;
        internal TextBox TB_Values;
        private System.Windows.Forms.Timer DisplayTimer;
        private GroupBox GB_ModuleInfo;
        private Button B_Connect;
        private Label label3;
        private Label label4;
        private Label label5;
        private TextBox TB_IPAddress_3;
        private TextBox TB_IPAddress_2;
        private TextBox TB_IPAddress_1;
        private TextBox TB_IPAddress_0;
        private Label label19;
        private Label L_MSXEInfo;
        private Label label6;
        private TextBox TB_SC_SignalPeriod;
        private Label label9;
        private ComboBox LB_SC_Resolution;
        private Label label12;
        private Label L_Frequency;
        private System.ComponentModel.IContainer components;

        public class ListData
        {
            private string myItem;
            private long myValue;

            public ListData(string strItem, long lValue)
            {

                this.myItem = strItem;
                this.myValue = lValue;
            }

            public string Item
            {
                get { return myItem; }
            }

            public long Value
            {

                get { return myValue; }
            }
        }

		public CyclicAcquisition()
		{
			//
			// Erforderlich fr die Windows Form-Designeruntersttzung
			//
			InitializeComponent();

			//
			// TODO: Fgen Sie den Konstruktorcode nach dem Aufruf von InitializeComponent hinzu
			//
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(CyclicAcquisition));
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.label1 = new System.Windows.Forms.Label();
            this.GB_CounterConfig = new System.Windows.Forms.GroupBox();
            this.CH_Counter3 = new System.Windows.Forms.CheckBox();
            this.CH_Counter2 = new System.Windows.Forms.CheckBox();
            this.CH_Counter1 = new System.Windows.Forms.CheckBox();
            this.CH_Counter0 = new System.Windows.Forms.CheckBox();
            this.L_IC_Label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.LB_SC_ValueFormat = new System.Windows.Forms.ComboBox();
            this.GB_Help = new System.Windows.Forms.GroupBox();
            this.L_Help = new System.Windows.Forms.Label();
            this.GB_Acquisition = new System.Windows.Forms.GroupBox();
            this.label11 = new System.Windows.Forms.Label();
            this.label10 = new System.Windows.Forms.Label();
            this.LB_ReadTime = new System.Windows.Forms.ComboBox();
            this.TB_TimeValue = new System.Windows.Forms.TextBox();
            this.TB_TransferNbr = new System.Windows.Forms.TextBox();
            this.label8 = new System.Windows.Forms.Label();
            this.TB_SequenceNbr = new System.Windows.Forms.TextBox();
            this.label7 = new System.Windows.Forms.Label();
            this.B_CounterInitialisation = new System.Windows.Forms.Button();
            this.B_ClearCounter = new System.Windows.Forms.Button();
            this.B_StartCounterAcquisition = new System.Windows.Forms.Button();
            this.B_StopCounterAcquisition = new System.Windows.Forms.Button();
            this.B_CounterReleaseInitialisation = new System.Windows.Forms.Button();
            this.GB_AcquisitionInfo = new System.Windows.Forms.GroupBox();
            this.TB_Values = new System.Windows.Forms.TextBox();
            this.DisplayTimer = new System.Windows.Forms.Timer(this.components);
            this.GB_ModuleInfo = new System.Windows.Forms.GroupBox();
            this.L_MSXEInfo = new System.Windows.Forms.Label();
            this.B_Connect = new System.Windows.Forms.Button();
            this.label3 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.TB_IPAddress_3 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_2 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_1 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_0 = new System.Windows.Forms.TextBox();
            this.label19 = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.TB_SC_SignalPeriod = new System.Windows.Forms.TextBox();
            this.LB_SC_Resolution = new System.Windows.Forms.ComboBox();
            this.label9 = new System.Windows.Forms.Label();
            this.label12 = new System.Windows.Forms.Label();
            this.L_Frequency = new System.Windows.Forms.Label();
            this.groupBox2.SuspendLayout();
            this.GB_CounterConfig.SuspendLayout();
            this.GB_Help.SuspendLayout();
            this.GB_Acquisition.SuspendLayout();
            this.GB_AcquisitionInfo.SuspendLayout();
            this.GB_ModuleInfo.SuspendLayout();
            this.SuspendLayout();
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.label1);
            this.groupBox2.Location = new System.Drawing.Point(8, 8);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(928, 48);
            this.groupBox2.TabIndex = 10;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Description";
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 16);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(914, 24);
            this.label1.TabIndex = 0;
            this.label1.Text = "This sample make a cyclic acquisition from the counters via the sanchro timer and" +
                " the synchro latch event";
            // 
            // GB_CounterConfig
            // 
            this.GB_CounterConfig.Controls.Add(this.L_Frequency);
            this.GB_CounterConfig.Controls.Add(this.TB_SC_SignalPeriod);
            this.GB_CounterConfig.Controls.Add(this.CH_Counter3);
            this.GB_CounterConfig.Controls.Add(this.CH_Counter2);
            this.GB_CounterConfig.Controls.Add(this.CH_Counter1);
            this.GB_CounterConfig.Controls.Add(this.CH_Counter0);
            this.GB_CounterConfig.Controls.Add(this.label12);
            this.GB_CounterConfig.Controls.Add(this.L_IC_Label1);
            this.GB_CounterConfig.Controls.Add(this.label2);
            this.GB_CounterConfig.Controls.Add(this.label9);
            this.GB_CounterConfig.Controls.Add(this.label6);
            this.GB_CounterConfig.Controls.Add(this.LB_SC_ValueFormat);
            this.GB_CounterConfig.Controls.Add(this.LB_SC_Resolution);
            this.GB_CounterConfig.Location = new System.Drawing.Point(8, 194);
            this.GB_CounterConfig.Name = "GB_CounterConfig";
            this.GB_CounterConfig.Size = new System.Drawing.Size(385, 170);
            this.GB_CounterConfig.TabIndex = 76;
            this.GB_CounterConfig.TabStop = false;
            this.GB_CounterConfig.Text = "Counter(s) configuration";
            // 
            // CH_Counter3
            // 
            this.CH_Counter3.AutoSize = true;
            this.CH_Counter3.Checked = true;
            this.CH_Counter3.CheckState = System.Windows.Forms.CheckState.Checked;
            this.CH_Counter3.Location = new System.Drawing.Point(302, 31);
            this.CH_Counter3.Name = "CH_Counter3";
            this.CH_Counter3.Size = new System.Drawing.Size(32, 17);
            this.CH_Counter3.TabIndex = 7;
            this.CH_Counter3.Text = "3";
            this.CH_Counter3.UseVisualStyleBackColor = true;
            // 
            // CH_Counter2
            // 
            this.CH_Counter2.AutoSize = true;
            this.CH_Counter2.Checked = true;
            this.CH_Counter2.CheckState = System.Windows.Forms.CheckState.Checked;
            this.CH_Counter2.Location = new System.Drawing.Point(264, 31);
            this.CH_Counter2.Name = "CH_Counter2";
            this.CH_Counter2.Size = new System.Drawing.Size(32, 17);
            this.CH_Counter2.TabIndex = 6;
            this.CH_Counter2.Text = "2";
            this.CH_Counter2.UseVisualStyleBackColor = true;
            // 
            // CH_Counter1
            // 
            this.CH_Counter1.AutoSize = true;
            this.CH_Counter1.Checked = true;
            this.CH_Counter1.CheckState = System.Windows.Forms.CheckState.Checked;
            this.CH_Counter1.Location = new System.Drawing.Point(226, 31);
            this.CH_Counter1.Name = "CH_Counter1";
            this.CH_Counter1.Size = new System.Drawing.Size(32, 17);
            this.CH_Counter1.TabIndex = 5;
            this.CH_Counter1.Text = "1";
            this.CH_Counter1.UseVisualStyleBackColor = true;
            // 
            // CH_Counter0
            // 
            this.CH_Counter0.AutoSize = true;
            this.CH_Counter0.Checked = true;
            this.CH_Counter0.CheckState = System.Windows.Forms.CheckState.Checked;
            this.CH_Counter0.Location = new System.Drawing.Point(188, 31);
            this.CH_Counter0.Name = "CH_Counter0";
            this.CH_Counter0.Size = new System.Drawing.Size(32, 17);
            this.CH_Counter0.TabIndex = 4;
            this.CH_Counter0.Text = "0";
            this.CH_Counter0.UseVisualStyleBackColor = true;
            // 
            // L_IC_Label1
            // 
            this.L_IC_Label1.AutoSize = true;
            this.L_IC_Label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.L_IC_Label1.Location = new System.Drawing.Point(44, 119);
            this.L_IC_Label1.Name = "L_IC_Label1";
            this.L_IC_Label1.Size = new System.Drawing.Size(66, 13);
            this.L_IC_Label1.TabIndex = 47;
            this.L_IC_Label1.Text = "Value format";
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.Location = new System.Drawing.Point(44, 31);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(100, 13);
            this.label2.TabIndex = 46;
            this.label2.Text = "Counter(s) selection";
            // 
            // LB_SC_ValueFormat
            // 
            this.LB_SC_ValueFormat.AllowDrop = true;
            this.LB_SC_ValueFormat.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.LB_SC_ValueFormat.FormattingEnabled = true;
            this.LB_SC_ValueFormat.Location = new System.Drawing.Point(176, 116);
            this.LB_SC_ValueFormat.Name = "LB_SC_ValueFormat";
            this.LB_SC_ValueFormat.Size = new System.Drawing.Size(146, 21);
            this.LB_SC_ValueFormat.TabIndex = 9;
            // 
            // GB_Help
            // 
            this.GB_Help.Controls.Add(this.L_Help);
            this.GB_Help.Location = new System.Drawing.Point(8, 62);
            this.GB_Help.Name = "GB_Help";
            this.GB_Help.Size = new System.Drawing.Size(928, 56);
            this.GB_Help.TabIndex = 93;
            this.GB_Help.TabStop = false;
            this.GB_Help.Text = "Help";
            // 
            // L_Help
            // 
            this.L_Help.Location = new System.Drawing.Point(8, 16);
            this.L_Help.Name = "L_Help";
            this.L_Help.Size = new System.Drawing.Size(914, 32);
            this.L_Help.TabIndex = 0;
            this.L_Help.Text = resources.GetString("L_Help.Text");
            this.L_Help.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // GB_Acquisition
            // 
            this.GB_Acquisition.Controls.Add(this.label11);
            this.GB_Acquisition.Controls.Add(this.label10);
            this.GB_Acquisition.Controls.Add(this.LB_ReadTime);
            this.GB_Acquisition.Controls.Add(this.TB_TimeValue);
            this.GB_Acquisition.Controls.Add(this.TB_TransferNbr);
            this.GB_Acquisition.Controls.Add(this.label8);
            this.GB_Acquisition.Controls.Add(this.TB_SequenceNbr);
            this.GB_Acquisition.Controls.Add(this.label7);
            this.GB_Acquisition.Location = new System.Drawing.Point(401, 194);
            this.GB_Acquisition.Name = "GB_Acquisition";
            this.GB_Acquisition.Size = new System.Drawing.Size(535, 170);
            this.GB_Acquisition.TabIndex = 94;
            this.GB_Acquisition.TabStop = false;
            this.GB_Acquisition.Text = "Acquisition configuration";
            // 
            // label11
            // 
            this.label11.AutoSize = true;
            this.label11.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label11.Location = new System.Drawing.Point(45, 110);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(84, 13);
            this.label11.TabIndex = 96;
            this.label11.Text = "Read time value";
            // 
            // label10
            // 
            this.label10.AutoSize = true;
            this.label10.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label10.Location = new System.Drawing.Point(45, 87);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(84, 13);
            this.label10.TabIndex = 95;
            this.label10.Text = "Read time base ";
            // 
            // LB_ReadTime
            // 
            this.LB_ReadTime.AllowDrop = true;
            this.LB_ReadTime.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.LB_ReadTime.FormattingEnabled = true;
            this.LB_ReadTime.Location = new System.Drawing.Point(394, 84);
            this.LB_ReadTime.Name = "LB_ReadTime";
            this.LB_ReadTime.Size = new System.Drawing.Size(92, 21);
            this.LB_ReadTime.TabIndex = 12;
            // 
            // TB_TimeValue
            // 
            this.TB_TimeValue.Location = new System.Drawing.Point(395, 108);
            this.TB_TimeValue.Name = "TB_TimeValue";
            this.TB_TimeValue.Size = new System.Drawing.Size(91, 20);
            this.TB_TimeValue.TabIndex = 13;
            this.TB_TimeValue.Text = "25";
            // 
            // TB_TransferNbr
            // 
            this.TB_TransferNbr.Location = new System.Drawing.Point(395, 61);
            this.TB_TransferNbr.Name = "TB_TransferNbr";
            this.TB_TransferNbr.Size = new System.Drawing.Size(91, 20);
            this.TB_TransferNbr.TabIndex = 11;
            this.TB_TransferNbr.Text = "10";
            // 
            // label8
            // 
            this.label8.AutoSize = true;
            this.label8.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label8.Location = new System.Drawing.Point(45, 64);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(332, 13);
            this.label8.TabIndex = 88;
            this.label8.Text = "Nbr of read sequences to acquire before the data are sent  (1 to 200)";
            // 
            // TB_SequenceNbr
            // 
            this.TB_SequenceNbr.Location = new System.Drawing.Point(395, 38);
            this.TB_SequenceNbr.Name = "TB_SequenceNbr";
            this.TB_SequenceNbr.Size = new System.Drawing.Size(91, 20);
            this.TB_SequenceNbr.TabIndex = 10;
            this.TB_SequenceNbr.Text = "100";
            // 
            // label7
            // 
            this.label7.AutoSize = true;
            this.label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label7.Location = new System.Drawing.Point(45, 41);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(327, 13);
            this.label7.TabIndex = 86;
            this.label7.Text = "How many read counter (s) sequence must be run (0 for continuous)";
            // 
            // B_CounterInitialisation
            // 
            this.B_CounterInitialisation.Enabled = false;
            this.B_CounterInitialisation.Location = new System.Drawing.Point(11, 370);
            this.B_CounterInitialisation.Name = "B_CounterInitialisation";
            this.B_CounterInitialisation.Size = new System.Drawing.Size(173, 29);
            this.B_CounterInitialisation.TabIndex = 14;
            this.B_CounterInitialisation.Text = "Counter(s) initialisation";
            this.B_CounterInitialisation.UseVisualStyleBackColor = true;
            this.B_CounterInitialisation.Click += new System.EventHandler(this.B_CounterInitialisation_Click);
            // 
            // B_ClearCounter
            // 
            this.B_ClearCounter.Enabled = false;
            this.B_ClearCounter.Location = new System.Drawing.Point(388, 370);
            this.B_ClearCounter.Name = "B_ClearCounter";
            this.B_ClearCounter.Size = new System.Drawing.Size(173, 29);
            this.B_ClearCounter.TabIndex = 16;
            this.B_ClearCounter.Text = "Clear counter(s)";
            this.B_ClearCounter.UseVisualStyleBackColor = true;
            this.B_ClearCounter.Click += new System.EventHandler(this.B_ClearCounter_Click);
            // 
            // B_StartCounterAcquisition
            // 
            this.B_StartCounterAcquisition.Enabled = false;
            this.B_StartCounterAcquisition.Location = new System.Drawing.Point(584, 370);
            this.B_StartCounterAcquisition.Name = "B_StartCounterAcquisition";
            this.B_StartCounterAcquisition.Size = new System.Drawing.Size(173, 29);
            this.B_StartCounterAcquisition.TabIndex = 19;
            this.B_StartCounterAcquisition.Text = "Start cyclic acquisition";
            this.B_StartCounterAcquisition.UseVisualStyleBackColor = true;
            this.B_StartCounterAcquisition.Click += new System.EventHandler(this.B_StartCounterAcquisition_Click);
            // 
            // B_StopCounterAcquisition
            // 
            this.B_StopCounterAcquisition.Enabled = false;
            this.B_StopCounterAcquisition.Location = new System.Drawing.Point(763, 370);
            this.B_StopCounterAcquisition.Name = "B_StopCounterAcquisition";
            this.B_StopCounterAcquisition.Size = new System.Drawing.Size(173, 29);
            this.B_StopCounterAcquisition.TabIndex = 20;
            this.B_StopCounterAcquisition.Text = "Stop cyclic acquisition";
            this.B_StopCounterAcquisition.UseVisualStyleBackColor = true;
            this.B_StopCounterAcquisition.Click += new System.EventHandler(this.B_StopCounterAcquisition_Click);
            // 
            // B_CounterReleaseInitialisation
            // 
            this.B_CounterReleaseInitialisation.Enabled = false;
            this.B_CounterReleaseInitialisation.Location = new System.Drawing.Point(190, 370);
            this.B_CounterReleaseInitialisation.Name = "B_CounterReleaseInitialisation";
            this.B_CounterReleaseInitialisation.Size = new System.Drawing.Size(173, 29);
            this.B_CounterReleaseInitialisation.TabIndex = 15;
            this.B_CounterReleaseInitialisation.Text = "Release counter(s) initialisation";
            this.B_CounterReleaseInitialisation.UseVisualStyleBackColor = true;
            this.B_CounterReleaseInitialisation.Click += new System.EventHandler(this.B_CounterReleaseInitialisation_Click);
            // 
            // GB_AcquisitionInfo
            // 
            this.GB_AcquisitionInfo.Controls.Add(this.TB_Values);
            this.GB_AcquisitionInfo.Location = new System.Drawing.Point(8, 405);
            this.GB_AcquisitionInfo.Name = "GB_AcquisitionInfo";
            this.GB_AcquisitionInfo.Size = new System.Drawing.Size(934, 138);
            this.GB_AcquisitionInfo.TabIndex = 99;
            this.GB_AcquisitionInfo.TabStop = false;
            this.GB_AcquisitionInfo.Text = "Sequence information";
            // 
            // TB_Values
            // 
            this.TB_Values.Font = new System.Drawing.Font("Courier New", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_Values.Location = new System.Drawing.Point(11, 19);
            this.TB_Values.Multiline = true;
            this.TB_Values.Name = "TB_Values";
            this.TB_Values.ReadOnly = true;
            this.TB_Values.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.TB_Values.Size = new System.Drawing.Size(917, 107);
            this.TB_Values.TabIndex = 140;
            this.TB_Values.TabStop = false;
            // 
            // DisplayTimer
            // 
            this.DisplayTimer.Interval = 1;
            this.DisplayTimer.Tick += new System.EventHandler(this.DisplayTimer_Tick);
            // 
            // GB_ModuleInfo
            // 
            this.GB_ModuleInfo.Controls.Add(this.L_MSXEInfo);
            this.GB_ModuleInfo.Controls.Add(this.B_Connect);
            this.GB_ModuleInfo.Controls.Add(this.label3);
            this.GB_ModuleInfo.Controls.Add(this.label4);
            this.GB_ModuleInfo.Controls.Add(this.label5);
            this.GB_ModuleInfo.Controls.Add(this.TB_IPAddress_3);
            this.GB_ModuleInfo.Controls.Add(this.TB_IPAddress_2);
            this.GB_ModuleInfo.Controls.Add(this.TB_IPAddress_1);
            this.GB_ModuleInfo.Controls.Add(this.TB_IPAddress_0);
            this.GB_ModuleInfo.Controls.Add(this.label19);
            this.GB_ModuleInfo.Location = new System.Drawing.Point(8, 130);
            this.GB_ModuleInfo.Name = "GB_ModuleInfo";
            this.GB_ModuleInfo.Size = new System.Drawing.Size(928, 58);
            this.GB_ModuleInfo.TabIndex = 100;
            this.GB_ModuleInfo.TabStop = false;
            this.GB_ModuleInfo.Text = "Module selection";
            // 
            // L_MSXEInfo
            // 
            this.L_MSXEInfo.Location = new System.Drawing.Point(544, 13);
            this.L_MSXEInfo.Name = "L_MSXEInfo";
            this.L_MSXEInfo.Size = new System.Drawing.Size(378, 36);
            this.L_MSXEInfo.TabIndex = 102;
            this.L_MSXEInfo.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // B_Connect
            // 
            this.B_Connect.Location = new System.Drawing.Point(447, 20);
            this.B_Connect.Name = "B_Connect";
            this.B_Connect.Size = new System.Drawing.Size(91, 29);
            this.B_Connect.TabIndex = 97;
            this.B_Connect.Text = "Connect";
            this.B_Connect.UseVisualStyleBackColor = true;
            this.B_Connect.Click += new System.EventHandler(this.B_Connect_Click);
            // 
            // label3
            // 
            this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label3.Location = new System.Drawing.Point(393, 25);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(8, 16);
            this.label3.TabIndex = 101;
            this.label3.Text = "-";
            // 
            // label4
            // 
            this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label4.Location = new System.Drawing.Point(337, 25);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(8, 16);
            this.label4.TabIndex = 100;
            this.label4.Text = "-";
            // 
            // label5
            // 
            this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label5.Location = new System.Drawing.Point(281, 25);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(8, 16);
            this.label5.TabIndex = 99;
            this.label5.Text = "-";
            // 
            // TB_IPAddress_3
            // 
            this.TB_IPAddress_3.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_IPAddress_3.Location = new System.Drawing.Point(409, 25);
            this.TB_IPAddress_3.MaxLength = 3;
            this.TB_IPAddress_3.Name = "TB_IPAddress_3";
            this.TB_IPAddress_3.Size = new System.Drawing.Size(32, 20);
            this.TB_IPAddress_3.TabIndex = 96;
            // 
            // TB_IPAddress_2
            // 
            this.TB_IPAddress_2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_IPAddress_2.Location = new System.Drawing.Point(353, 25);
            this.TB_IPAddress_2.MaxLength = 3;
            this.TB_IPAddress_2.Name = "TB_IPAddress_2";
            this.TB_IPAddress_2.Size = new System.Drawing.Size(32, 20);
            this.TB_IPAddress_2.TabIndex = 95;
            // 
            // TB_IPAddress_1
            // 
            this.TB_IPAddress_1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_IPAddress_1.Location = new System.Drawing.Point(297, 25);
            this.TB_IPAddress_1.MaxLength = 3;
            this.TB_IPAddress_1.Name = "TB_IPAddress_1";
            this.TB_IPAddress_1.Size = new System.Drawing.Size(32, 20);
            this.TB_IPAddress_1.TabIndex = 94;
            // 
            // TB_IPAddress_0
            // 
            this.TB_IPAddress_0.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_IPAddress_0.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.TB_IPAddress_0.Location = new System.Drawing.Point(241, 25);
            this.TB_IPAddress_0.MaxLength = 3;
            this.TB_IPAddress_0.Name = "TB_IPAddress_0";
            this.TB_IPAddress_0.Size = new System.Drawing.Size(32, 20);
            this.TB_IPAddress_0.TabIndex = 93;
            // 
            // label19
            // 
            this.label19.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label19.Location = new System.Drawing.Point(27, 27);
            this.label19.Name = "label19";
            this.label19.Size = new System.Drawing.Size(208, 16);
            this.label19.TabIndex = 98;
            this.label19.Text = "IP address of the MSX-E170x module :";
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label6.Location = new System.Drawing.Point(44, 87);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(125, 13);
            this.label6.TabIndex = 46;
            this.label6.Text = "Signal period (m/period)";
            // 
            // TB_SC_SignalPeriod
            // 
            this.TB_SC_SignalPeriod.Location = new System.Drawing.Point(176, 86);
            this.TB_SC_SignalPeriod.Name = "TB_SC_SignalPeriod";
            this.TB_SC_SignalPeriod.Size = new System.Drawing.Size(146, 20);
            this.TB_SC_SignalPeriod.TabIndex = 48;
            // 
            // LB_SC_Resolution
            // 
            this.LB_SC_Resolution.AllowDrop = true;
            this.LB_SC_Resolution.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.LB_SC_Resolution.FormattingEnabled = true;
            this.LB_SC_Resolution.Location = new System.Drawing.Point(176, 54);
            this.LB_SC_Resolution.Name = "LB_SC_Resolution";
            this.LB_SC_Resolution.Size = new System.Drawing.Size(146, 21);
            this.LB_SC_Resolution.TabIndex = 8;
            // 
            // label9
            // 
            this.label9.AutoSize = true;
            this.label9.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label9.Location = new System.Drawing.Point(44, 57);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(57, 13);
            this.label9.TabIndex = 46;
            this.label9.Text = "Resolution";
            // 
            // label12
            // 
            this.label12.AutoSize = true;
            this.label12.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label12.Location = new System.Drawing.Point(44, 145);
            this.label12.Name = "label12";
            this.label12.Size = new System.Drawing.Size(126, 13);
            this.label12.TabIndex = 47;
            this.label12.Text = "Max. input frequency";
            // 
            // L_Frequency
            // 
            this.L_Frequency.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.L_Frequency.ForeColor = System.Drawing.Color.Blue;
            this.L_Frequency.Location = new System.Drawing.Point(173, 145);
            this.L_Frequency.Name = "L_Frequency";
            this.L_Frequency.Size = new System.Drawing.Size(149, 13);
            this.L_Frequency.TabIndex = 49;
            // 
            // CyclicAcquisition
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(954, 552);
            this.Controls.Add(this.GB_ModuleInfo);
            this.Controls.Add(this.GB_AcquisitionInfo);
            this.Controls.Add(this.B_CounterReleaseInitialisation);
            this.Controls.Add(this.B_StopCounterAcquisition);
            this.Controls.Add(this.B_StartCounterAcquisition);
            this.Controls.Add(this.B_ClearCounter);
            this.Controls.Add(this.B_CounterInitialisation);
            this.Controls.Add(this.GB_Acquisition);
            this.Controls.Add(this.GB_Help);
            this.Controls.Add(this.GB_CounterConfig);
            this.Controls.Add(this.groupBox2);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "CyclicAcquisition";
            this.Text = "C# Counter(s) cyclic acquisition";
            this.Load += new System.EventHandler(this.CyclicAcquisition_Load);
            this.Closed += new System.EventHandler(this.CyclicAcquisition_Closed);
            this.groupBox2.ResumeLayout(false);
            this.GB_CounterConfig.ResumeLayout(false);
            this.GB_CounterConfig.PerformLayout();
            this.GB_Help.ResumeLayout(false);
            this.GB_Acquisition.ResumeLayout(false);
            this.GB_Acquisition.PerformLayout();
            this.GB_AcquisitionInfo.ResumeLayout(false);
            this.GB_AcquisitionInfo.PerformLayout();
            this.GB_ModuleInfo.ResumeLayout(false);
            this.GB_ModuleInfo.PerformLayout();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new CyclicAcquisition());
		}

        public static String ConvertFromTime_T(byte[] bBuffer, int iIndex)
        {
            ulong ulTimeStampLow = BitConverter.ToUInt32(bBuffer, iIndex);
            ulong ulTimeStampHigh = BitConverter.ToUInt32(bBuffer, iIndex + 4);

            return (ConvertFromTime_T(ulTimeStampHigh, ulTimeStampLow));
        }

        public static String ConvertFromTime_T(ulong ulTimeStampHigh, ulong ulTimeStampLow)
        {
            ulong ulTimeStampLowms = (ulong)(ulTimeStampLow / 1000);
            ulong ulTimeStampLowmus = (ulong)(ulTimeStampLow % 1000);

            DateTime dt70 = new DateTime(1970, 1, 1, 0, 0, 0, 0);
            long tickTotal = dt70.Ticks + (long)(ulTimeStampHigh * 10000000L);
            DateTime netTimeT = new DateTime(tickTotal);
            return (netTimeT.ToString() + "." + ulTimeStampLowms.ToString("D3") + "." + ulTimeStampLowmus.ToString("D3"));
        }
        
        
        // Global Variable
		MXCommon_WebReference.MXCommon MX_Common;
		MSXE172x_WebReference.MSXE17xx MSXE17xx;
        Socket                         SocketClient = null;
        String                         DisplayText = "";
        AsyncClientStream              Client = null;
        CheckBox[]                     CounterList;
        int                            Counters = 0;
        byte                           bValueFormat = 0;

		private void CyclicAcquisition_Load(object sender, System.EventArgs e)
		{
			MX_Common = new MXCommon_WebReference.MXCommon();
            MSXE17xx  = new MSXE172x_WebReference.MSXE17xx();
			MX_Common.Timeout = 2000;
            MSXE17xx.Timeout = 2000;

            ArrayList Resolution = new ArrayList();
            Resolution.Add(new ListData("16", 16));
            Resolution.Add(new ListData("32", 32));
            Resolution.Add(new ListData("40", 40));
            Resolution.Add(new ListData("64", 64));
            Resolution.Add(new ListData("80", 80));
            Resolution.Add(new ListData("100", 100));
            Resolution.Add(new ListData("128", 128));
            Resolution.Add(new ListData("160", 160));
            Resolution.Add(new ListData("200", 200));
            Resolution.Add(new ListData("256", 256));
            Resolution.Add(new ListData("320", 320));
            Resolution.Add(new ListData("400", 400));
            Resolution.Add(new ListData("500", 500));
            Resolution.Add(new ListData("512", 512));
            Resolution.Add(new ListData("800", 800));
            Resolution.Add(new ListData("1000", 1000));
            Resolution.Add(new ListData("1024", 1024));
            Resolution.Add(new ListData("1600", 1600));
            Resolution.Add(new ListData("2000", 2000));
            Resolution.Add(new ListData("2048", 2048));
            Resolution.Add(new ListData("4096", 4096));
            Resolution.Add(new ListData("8192", 8192));

            LB_SC_Resolution.DataSource = Resolution;
            LB_SC_Resolution.DisplayMember = "Item";
            LB_SC_Resolution.ValueMember = "Value";
            LB_SC_Resolution.SelectedIndex = 1;

            // Counter data format list box initialisation
            ArrayList ValueFormat = new ArrayList();
            ValueFormat.Add(new ListData("Raw data", 0));
            ValueFormat.Add(new ListData("Millimeters", 1));

            LB_SC_ValueFormat.DataSource = ValueFormat;
            LB_SC_ValueFormat.DisplayMember = "Item";
            LB_SC_ValueFormat.ValueMember = "Value";

            // Read time list box initialisation
            ArrayList ReadTimes = new ArrayList();
            ReadTimes.Add(new ListData("s", 0));
            ReadTimes.Add(new ListData("ms", 1));
            ReadTimes.Add(new ListData("s", 2));

            LB_ReadTime.DisplayMember = "Item";
            LB_ReadTime.ValueMember = "Value";
            LB_ReadTime.DataSource = ReadTimes;

            // Counter list initialisation
            CounterList = new CheckBox[4];
            CounterList[0] = CH_Counter0;
            CounterList[1] = CH_Counter1;
            CounterList[2] = CH_Counter2;
            CounterList[3] = CH_Counter3;
        }


		private void CyclicAcquisition_Closed(object sender, System.EventArgs e)
		{
            CloseAll();

            if (MSXE17xx != null)
			{
                MSXE17xx = null;
			}
			if (MX_Common != null)
			{
				MX_Common = null;
			}

			System.GC.Collect();
		}

        private void CloseAll ()
        {
            // Test if any acquisition in progress
            if (B_StopCounterAcquisition.Enabled == true)
            {
                // Test the current acquisition
                B_StopCounterAcquisition_Click(null, null);
            }

            // Test if counter initialised
            if (B_CounterReleaseInitialisation.Enabled == true)
            {
                // Release the counter initialisation
                B_CounterReleaseInitialisation_Click(null, null);
            }
        }

        private void B_Connect_Click(object sender, EventArgs e)
        {
            byte[] bModuleType = new byte[200];
            System.Text.ASCIIEncoding ASCIIEnc = new System.Text.ASCIIEncoding();

            if ((TB_IPAddress_0.Text.ToString() == "") || (TB_IPAddress_1.Text.ToString() == "") || (TB_IPAddress_2.Text.ToString() == "") || (TB_IPAddress_3.Text.ToString() == ""))
            {
                MessageBox.Show("The IP address you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                if ((Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) < 256))
                {
                    if ((Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) < 256))
                    {
                        if ((Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) < 256))
                        {
                            if ((Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) < 256))
                            {
                                CloseAll();

                                try
                                {
                                    MSXE17xx.Url = "http://" + TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text + ":5555";
                                    MX_Common.Url = MSXE17xx.Url;

                                    // Get the module type
                                    MX_Common.GetModuleType(out bModuleType);
                                    L_MSXEInfo.Text = ASCIIEnc.GetString(bModuleType);

                                    // Button initialisation
                                    B_CounterInitialisation.Enabled = true;
                                    B_CounterReleaseInitialisation.Enabled = false;
                                    B_ClearCounter.Enabled = false;
                                    B_StartCounterAcquisition.Enabled = false;
                                    B_StopCounterAcquisition.Enabled = false;
                                    GB_CounterConfig.Enabled = true;
                                    GB_Acquisition.Enabled = true;
                                }
                                catch (Exception ex)
                                {
                                    MessageBox.Show("SOAP connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                }
                            }
                            else
                            {
                                MessageBox.Show("The IP address (part 4) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                        }
                        else
                        {
                            MessageBox.Show("The IP address (part 3) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        }
                    }
                    else
                    {
                        MessageBox.Show("The IP address (part 2) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
                else
                {
                    MessageBox.Show("The IP address (part 1) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }
        }

        private void B_CounterInitialisation_Click(object sender, EventArgs e)
        {
            int   syserno             = 0;
            bool  boErrorOccur        = false;
            ulong ulInfo1             = 0;
            ulong ulInfo2             = 0;
            ulong ulMaxInputFrequency = 0;
            double dSiagnalPeriod     = 0.0;
            MSXE172x_WebReference.DefaultResponse  Response = new MSXE172x_WebReference.DefaultResponse();

            Counters = 0;

            try
            {
                dSiagnalPeriod = Convert.ToDouble(TB_SC_SignalPeriod.Text);
            }
            catch 
            {
                MessageBox.Show("Invalid format.", "Signal period", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            // Counter(s) initialisation
            for (ulong i = 0; (i < 4) && (boErrorOccur == false); i++)
            {
                // Test if counter used
                if (CounterList[i].Checked == true)
                {
                    try
                    {
                        bValueFormat = Convert.ToByte(LB_SC_ValueFormat.SelectedValue);

                        // Init the counter
                        Response = MSXE17xx.MFSinCosInitEx(i, 
                                                           1,
                                                           dSiagnalPeriod,
                                                           Convert.ToUInt32(LB_SC_Resolution.SelectedValue),
                                                           Convert.ToUInt32(LB_SC_ValueFormat.SelectedValue), 
                                                           0, 
                                                           0, 
                                                           0, 
                                                           0, 
                                                           out ulMaxInputFrequency, 
                                                           out ulInfo1, 
                                                           out ulInfo2);

                        if (Response.iReturnValue != 0)
                        {
                            boErrorOccur = true;
                            MessageBox.Show("MFSinCosInitEx Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

                            // Test if any counter already initialised
                            if (Counters != 0)
                            {
                                for (ulong j = 0; j < i; j++)
                                {
                                    // Test if counter used
                                    if (CounterList[j].Enabled == true)
                                    {
                                        MSXE17xx.MFSinCosRelease(j, 0, 0, out syserno);
                                    }
                                }
                            }
                        }
                        else
                        {
                            Counters = Counters + 1;
                            L_Frequency.Text = ulMaxInputFrequency.ToString() + " Hz";
                        }
                    }

                    catch (Exception ex)
                    {
                        boErrorOccur = true;
                        MessageBox.Show("SOAP connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
            }

            // Test if no counter selected
            if ((Counters == 0) && (boErrorOccur == false))
            {
                MessageBox.Show("No counter(s) selected", "Configuration error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else if (boErrorOccur == false)
            {
                // Button initialisation
                B_CounterInitialisation.Enabled = false;
                B_CounterReleaseInitialisation.Enabled = true;
                B_ClearCounter.Enabled = true;
                B_StartCounterAcquisition.Enabled = true;
                B_StopCounterAcquisition.Enabled = false;
                GB_CounterConfig.Enabled = false;
                GB_Acquisition.Enabled = true;
            }
        }

        private void B_CounterReleaseInitialisation_Click(object sender, EventArgs e)
        {
            int syserno = 0;
            int RetValue = 0;

            // Counter(s) release
            for (ulong i = 0; i < 4; i++)
            {
                // Test if counter used
                if (CounterList[i].Checked == true)
                {
                    // Release the counter initialisation
                    RetValue = MSXE17xx.MFSinCosRelease(i, 0, 0, out syserno);

                    // Init the counter
                    if (RetValue != 0)
                    {
                        MessageBox.Show("MFSinCosRelease Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
            }

            // Button initialisation
            B_CounterInitialisation.Enabled = true;
            B_CounterReleaseInitialisation.Enabled = false;
            B_ClearCounter.Enabled = false;
            B_StartCounterAcquisition.Enabled = false;
            B_StopCounterAcquisition.Enabled = false;
            GB_CounterConfig.Enabled = true;
            GB_Acquisition.Enabled = true;
        }

        private void B_ClearCounter_Click(object sender, EventArgs e)
        {
            int syserno = 0;
            int RetValue = 0;

            // Clear counter(s)
            for (ulong i = 0; i < 4; i++)
            {
                // Test if counter used
                if (CounterList[i].Checked == true)
                {
                    // Clear the counter 
                    RetValue = MSXE17xx.MFSinCosClear(i, 0, 0, out syserno);

                    if (RetValue != 0)
                    {
                        MessageBox.Show("MFSinCosClear Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
            }
        }

        private void B_StartCounterAcquisition_Click(object sender, EventArgs e)
        {
            ulong FIFOSize    = Convert.ToUInt32(TB_TransferNbr.Text);
            ulong SequenceNbr = Convert.ToUInt32(TB_SequenceNbr.Text);
            int syserno = 0;
            int RetValue = 0;
            bool boErrorOccur = false;
            Thread ClientThread;

            // Test the FIFO size
            if (FIFOSize >= 1 && FIFOSize <= 200)
            {
                if ((SequenceNbr < FIFOSize) && (SequenceNbr != 0))
                {
                    MessageBox.Show("Number of read sequence to acquire > total read sequence number", "Configuration error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
                }

                // Create the client stream
                Client = new AddiData.ADDISocket.AsyncClientStream();

                // Open the socket connection to receive the data
                SocketClient = null;
                SocketClient = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
                SocketClient.ReceiveBufferSize = 1048576;
                SocketClient.Connect(TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text, 8989);

                // Start the read socket and the user thread
                Client.SingleFramesSize = 5 * 4 * Counters;
                Client.NbrOfFrames = Convert.ToInt32(FIFOSize);
                Client.Start(SocketClient);
                ClientThread = new Thread(ClientThreadFct);
                DisplayText = "";

                // Counter(s) synchro latch initialisation
                for (ulong i = 0; (i < 4) && (boErrorOccur == false); i++)
                {
                    // Test if counter used
                    if (CounterList[i].Checked == true)
                    {
                        // Counter FIFO initialisation
                        RetValue = MSXE17xx.MFCommonSetFIFO0Level(i, FIFOSize, 0, 0, 0, 0, out syserno);

                        if (RetValue != 0)
                        {
                            MessageBox.Show("MFCommonSetFIFO0Level Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            boErrorOccur = true;
                        }
                        else
                        {
                            // Init the counter synchro latch
                            RetValue = MSXE17xx.MFSinCosInitAndEnableLatch(i, 2, 0, 1, 0, 0, out syserno);

                            if (RetValue != 0)
                            {
                                boErrorOccur = true;
                                MessageBox.Show("MFSinCosInitAndEnableLatch Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                        }

                        if (boErrorOccur == true)
                        {
                            for (ulong j = 0; j < i; j++)
                            {
                                // Test if counter used
                                if (CounterList[j].Enabled == true)
                                {
                                    MSXE17xx.MFSinCosDisableAndReleaseLatch(j, 2, 0, out syserno);
                                }
                            }
                        }
                    }
                }


                // Test if no error occur
                if (boErrorOccur == false)
                {
                    // Init and start the synchro timer
                    RetValue = MX_Common.InitAndStartSynchroTimer(Convert.ToUInt32(LB_ReadTime.SelectedValue),
                                                                  Convert.ToUInt32(TB_TimeValue.Text),
                                                                  Convert.ToUInt32(TB_SequenceNbr.Text),
                                                                  0,
                                                                  0,
                                                                  0,
                                                                  0,
                                                                  0,
                                                                  out syserno);

                    if (RetValue != 0)
                    {
                        boErrorOccur = true;
                        MessageBox.Show("InitAndStartSynchroTimer Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

                        for (ulong i = 0; i < 4; i++)
                        {
                            // Test if counter used
                            if (CounterList[i].Enabled == true)
                            {
                                // Disable the syncho latch
                                MSXE17xx.MFSinCosDisableAndReleaseLatch(i, 2, 0, out syserno);
                            }
                        }
                    }
                    else
                    {
                        // Start the display timer and read socket thread
                        DisplayTimer.Enabled = true;
                        ClientThread.Priority = ThreadPriority.Lowest;
                        ClientThread.Start();

                        // Button initialisation
                        B_CounterInitialisation.Enabled = false;
                        B_CounterReleaseInitialisation.Enabled = false;
                        B_ClearCounter.Enabled = true;
                        B_StartCounterAcquisition.Enabled = false;
                        B_StopCounterAcquisition.Enabled = true;
                        GB_CounterConfig.Enabled = false;
                        GB_Acquisition.Enabled = false;
                    }
                }

                // Test if error occur
                if (boErrorOccur == true)
                {
                    // Stop the data server 
                    Client.Stoop();

                    try
                    {
                        // Close the socket connection
                        SocketClient.Shutdown(SocketShutdown.Both);
                        SocketClient.Close();
                        SocketClient = null;
                        System.GC.Collect();
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show("Socket close connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
            }
            else
            {
                MessageBox.Show("Number of read sequence to acquire not OK", "Configuration error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        private void B_StopCounterAcquisition_Click(object sender, EventArgs e)
        {
            int syserno = 0;
            int RetValue = 0;

            // Stop the data server 
            Client.Stoop();

            try
            {
                // Close the socket connection
                SocketClient.Shutdown(SocketShutdown.Both);
                SocketClient.Close();
                SocketClient = null;
                System.GC.Collect();
            }
            catch (Exception ex)
            {
                MessageBox.Show("Socket close connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

            // Stop and release the synchro timer
            RetValue = MX_Common.StopAndReleaseSynchroTimer(0, out syserno);

            if (RetValue != 0)
            {
                MessageBox.Show("StopAndReleaseSynchroTimer Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

            // Disable synchro latch from counter(s)
            for (ulong i = 0; i < 4; i++)
            {
                // Test if counter used
                if (CounterList[i].Checked == true)
                {
                    // Disable the syncho latch
                    RetValue = MSXE17xx.MFSinCosDisableAndReleaseLatch(i, 2, 0, out syserno);

                    if (RetValue != 0)
                    {
                        MessageBox.Show("MFSinCosDisableAndReleaseLatch Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
            }

            // Button initialisation
            B_CounterInitialisation.Enabled = false;
            B_CounterReleaseInitialisation.Enabled = true;
            B_ClearCounter.Enabled = true;
            B_StartCounterAcquisition.Enabled = true;
            B_StopCounterAcquisition.Enabled = false;
            GB_CounterConfig.Enabled = false;
            GB_Acquisition.Enabled = true;
        }

        private void ClientThreadFct()
        {
            byte[] SocketData;
            int StreamCounter = 0;
            int Offset = 0;
            int Counter = 0;
            ulong Source = 0;
            ulong AcquisitionCounter = 0;
            String sOutString;
            Single fValue;

            while ((SocketData = Client.ReadData()) != null)
            {
                sOutString = "";
                Offset = 0;

                for (StreamCounter = 0; StreamCounter < Client.NbrOfFrames; StreamCounter++)
                {
                    for (Counter = 0; Counter < Counters; Counter++)
                    {
                        Offset = (StreamCounter + (Client.NbrOfFrames * Counter)) * 5 * 4;
                        // 
                        sOutString = sOutString + "Acquisition counter: " + AcquisitionCounter.ToString();

                        // Get the time stamp
                        sOutString = sOutString + " / Time stamp: " + ConvertFromTime_T(SocketData, Offset);
                        Offset = Offset + 8;

                        // Get the counter nbr
                        sOutString = sOutString + " / counter: " + (BitConverter.ToUInt32(SocketData, Offset) & 3).ToString();
                        Offset = Offset + 4;

                        // Get the source
                        Source = BitConverter.ToUInt32(SocketData, Offset);
                        sOutString = sOutString + " / source: " + (Source & 0x7FFFFFFFUL).ToString();
                        Offset = Offset + 4;

                        // Get the counter value
                        if (bValueFormat == 0)
                        {
                            sOutString = sOutString + " / value: " + BitConverter.ToUInt32(SocketData, Offset).ToString();
                        }
                        else
                        {
                            fValue = BitConverter.ToSingle(SocketData, Offset);

                            if (Math.Abs(fValue) < 0.0001)
                            {
                                if (Math.Abs(fValue) < 0.0000001)
                                {
                                    sOutString = sOutString + " / position: " + (fValue * 1000000.0).ToString("F3") + "nm";
                                }
                                else
                                {
                                    sOutString = sOutString + " / position: " + (fValue * 1000.0).ToString("F3") + "m";
                                }
                            }
                            else
                            {
                                sOutString = sOutString + " / position: " + fValue.ToString("F3") + "mm";
                            }
                        }

                        // Test if measure error occur
                        sOutString = sOutString + " / error: " + (Source >> 31).ToString() + Environment.NewLine;

                        AcquisitionCounter++;
                    }
                }

                DisplayText = DisplayText + sOutString;
            }
        }

        private void DisplayTimer_Tick(object sender, EventArgs e)
        {
            TB_Values.Text = DisplayText;
        }
    }
}
