using System;
using System.Threading;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.Net.Sockets;
using AddiData.ADDISocket;
using System.Text.RegularExpressions;

namespace CyclicAcquisitionHWTriggerGate
{
	/// <summary>
	/// Zusammenfassung fr CyclicAcquisition.
	/// </summary>
    public class CyclicAcquisitionHWTriggerGate : System.Windows.Forms.Form
    {
        private System.Windows.Forms.GroupBox descriptionGroupBox;
        private GroupBox counterConfigGroupBox;
        private ComboBox valueFormatComboBox;
        private CheckBox CH_Counter3;
        private CheckBox CH_Counter2;
        private CheckBox CH_Counter1;
        private CheckBox CH_Counter0;
        private GroupBox helpGroupBox;
        private GroupBox acquisitionConfigurationGroupBox;
        private TextBox TB_TransferNbr;
        private TextBox TB_SequenceNbr;
        private Label readTimeBaseLabel;
        private ComboBox LB_ReadTime;
        private TextBox readTimeValueTextBox;
        private Button counterInitialisationButton;
        private Button clearCounterButton;
        private Button startCounterAcquisitionButton;
        private Button stopCounterAcquisitionButton;
        private Button counterReleaseInitialisationButton;
        private GroupBox sequenceInformationGroupBox;
        internal TextBox valuesTextbox;
        private System.Windows.Forms.Timer DisplayTimer;
        private GroupBox moduleSelectionGroupBox;
        private Button connectButton;
        private Label label3;
        private Label label4;
        private Label label5;
        private TextBox IP3Textbox;
        private TextBox IP2Textbox;
        private TextBox IP1Textbox;
        private TextBox IP0Textbox;
        private Label L_MSXEInfo;
        private TextBox signalPeriodTextBox;
        private ComboBox resolutionComboBox;
        private Label L_Frequency;
        private CheckBox gateCounter3CheckBox;
        private CheckBox gateCounter2CheckBox;
        private CheckBox gateCounter1CheckBox;
        private CheckBox gateCounter0CheckBox;
        private Button disableGateButton;
        private Button enableGateButton;
        private GroupBox controlsGroupBox;
        private GroupBox counterGroupBox;
        private System.ComponentModel.IContainer components;

        public class ListData
        {
            private string myItem;
            private long myValue;

            public ListData(string strItem, long lValue)
            {

                this.myItem = strItem;
                this.myValue = lValue;
            }

            public string Item
            {
                get { return myItem; }
            }

            public long Value
            {

                get { return myValue; }
            }
        }

		public CyclicAcquisitionHWTriggerGate()
		{
			//
			// Erforderlich fr die Windows Form-Designeruntersttzung
			//
			InitializeComponent();

			//
			// TODO: Fgen Sie den Konstruktorcode nach dem Aufruf von InitializeComponent hinzu
			//
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.Windows.Forms.Label descriptionLabel;
            System.Windows.Forms.Label triggerGateSelectionLabel;
            System.Windows.Forms.Label maxInputFrequencyLabel;
            System.Windows.Forms.Label valueFormatLabel;
            System.Windows.Forms.Label counterSelectionLabel;
            System.Windows.Forms.Label resolutionLabel;
            System.Windows.Forms.Label signalPeriodLabel;
            System.Windows.Forms.Label helpLabel;
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(CyclicAcquisitionHWTriggerGate));
            System.Windows.Forms.Label readTimeValueLabel;
            System.Windows.Forms.Label readSequencLabel;
            System.Windows.Forms.Label sequenceCounterLabel;
            System.Windows.Forms.Label ipAddressLabel;
            this.descriptionGroupBox = new System.Windows.Forms.GroupBox();
            this.counterConfigGroupBox = new System.Windows.Forms.GroupBox();
            this.gateCounter3CheckBox = new System.Windows.Forms.CheckBox();
            this.gateCounter2CheckBox = new System.Windows.Forms.CheckBox();
            this.gateCounter1CheckBox = new System.Windows.Forms.CheckBox();
            this.gateCounter0CheckBox = new System.Windows.Forms.CheckBox();
            this.L_Frequency = new System.Windows.Forms.Label();
            this.signalPeriodTextBox = new System.Windows.Forms.TextBox();
            this.CH_Counter3 = new System.Windows.Forms.CheckBox();
            this.CH_Counter2 = new System.Windows.Forms.CheckBox();
            this.CH_Counter1 = new System.Windows.Forms.CheckBox();
            this.CH_Counter0 = new System.Windows.Forms.CheckBox();
            this.valueFormatComboBox = new System.Windows.Forms.ComboBox();
            this.resolutionComboBox = new System.Windows.Forms.ComboBox();
            this.helpGroupBox = new System.Windows.Forms.GroupBox();
            this.acquisitionConfigurationGroupBox = new System.Windows.Forms.GroupBox();
            this.readTimeBaseLabel = new System.Windows.Forms.Label();
            this.LB_ReadTime = new System.Windows.Forms.ComboBox();
            this.readTimeValueTextBox = new System.Windows.Forms.TextBox();
            this.TB_TransferNbr = new System.Windows.Forms.TextBox();
            this.TB_SequenceNbr = new System.Windows.Forms.TextBox();
            this.counterInitialisationButton = new System.Windows.Forms.Button();
            this.clearCounterButton = new System.Windows.Forms.Button();
            this.startCounterAcquisitionButton = new System.Windows.Forms.Button();
            this.stopCounterAcquisitionButton = new System.Windows.Forms.Button();
            this.counterReleaseInitialisationButton = new System.Windows.Forms.Button();
            this.sequenceInformationGroupBox = new System.Windows.Forms.GroupBox();
            this.valuesTextbox = new System.Windows.Forms.TextBox();
            this.DisplayTimer = new System.Windows.Forms.Timer(this.components);
            this.moduleSelectionGroupBox = new System.Windows.Forms.GroupBox();
            this.L_MSXEInfo = new System.Windows.Forms.Label();
            this.connectButton = new System.Windows.Forms.Button();
            this.label3 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.IP3Textbox = new System.Windows.Forms.TextBox();
            this.IP2Textbox = new System.Windows.Forms.TextBox();
            this.IP1Textbox = new System.Windows.Forms.TextBox();
            this.IP0Textbox = new System.Windows.Forms.TextBox();
            this.disableGateButton = new System.Windows.Forms.Button();
            this.enableGateButton = new System.Windows.Forms.Button();
            this.controlsGroupBox = new System.Windows.Forms.GroupBox();
            this.counterGroupBox = new System.Windows.Forms.GroupBox();
            descriptionLabel = new System.Windows.Forms.Label();
            triggerGateSelectionLabel = new System.Windows.Forms.Label();
            maxInputFrequencyLabel = new System.Windows.Forms.Label();
            valueFormatLabel = new System.Windows.Forms.Label();
            counterSelectionLabel = new System.Windows.Forms.Label();
            resolutionLabel = new System.Windows.Forms.Label();
            signalPeriodLabel = new System.Windows.Forms.Label();
            helpLabel = new System.Windows.Forms.Label();
            readTimeValueLabel = new System.Windows.Forms.Label();
            readSequencLabel = new System.Windows.Forms.Label();
            sequenceCounterLabel = new System.Windows.Forms.Label();
            ipAddressLabel = new System.Windows.Forms.Label();
            this.descriptionGroupBox.SuspendLayout();
            this.counterConfigGroupBox.SuspendLayout();
            this.helpGroupBox.SuspendLayout();
            this.acquisitionConfigurationGroupBox.SuspendLayout();
            this.sequenceInformationGroupBox.SuspendLayout();
            this.moduleSelectionGroupBox.SuspendLayout();
            this.controlsGroupBox.SuspendLayout();
            this.counterGroupBox.SuspendLayout();
            this.SuspendLayout();
            // 
            // descriptionLabel
            // 
            descriptionLabel.Location = new System.Drawing.Point(8, 16);
            descriptionLabel.Name = "descriptionLabel";
            descriptionLabel.Size = new System.Drawing.Size(914, 24);
            descriptionLabel.TabIndex = 0;
            descriptionLabel.Text = "This sample make a cyclic acquisition from the counters via the sanchro timer and" +
                " the synchro latch event";
            // 
            // triggerGateSelectionLabel
            // 
            triggerGateSelectionLabel.AutoSize = true;
            triggerGateSelectionLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            triggerGateSelectionLabel.Location = new System.Drawing.Point(44, 45);
            triggerGateSelectionLabel.Name = "triggerGateSelectionLabel";
            triggerGateSelectionLabel.Size = new System.Drawing.Size(109, 13);
            triggerGateSelectionLabel.TabIndex = 54;
            triggerGateSelectionLabel.Text = "Trigger gate selection";
            // 
            // maxInputFrequencyLabel
            // 
            maxInputFrequencyLabel.AutoSize = true;
            maxInputFrequencyLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            maxInputFrequencyLabel.Location = new System.Drawing.Point(44, 163);
            maxInputFrequencyLabel.Name = "maxInputFrequencyLabel";
            maxInputFrequencyLabel.Size = new System.Drawing.Size(126, 13);
            maxInputFrequencyLabel.TabIndex = 47;
            maxInputFrequencyLabel.Text = "Max. input frequency";
            // 
            // valueFormatLabel
            // 
            valueFormatLabel.AutoSize = true;
            valueFormatLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            valueFormatLabel.Location = new System.Drawing.Point(44, 137);
            valueFormatLabel.Name = "valueFormatLabel";
            valueFormatLabel.Size = new System.Drawing.Size(66, 13);
            valueFormatLabel.TabIndex = 47;
            valueFormatLabel.Text = "Value format";
            // 
            // counterSelectionLabel
            // 
            counterSelectionLabel.AutoSize = true;
            counterSelectionLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            counterSelectionLabel.Location = new System.Drawing.Point(44, 22);
            counterSelectionLabel.Name = "counterSelectionLabel";
            counterSelectionLabel.Size = new System.Drawing.Size(100, 13);
            counterSelectionLabel.TabIndex = 46;
            counterSelectionLabel.Text = "Counter(s) selection";
            // 
            // resolutionLabel
            // 
            resolutionLabel.AutoSize = true;
            resolutionLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            resolutionLabel.Location = new System.Drawing.Point(44, 75);
            resolutionLabel.Name = "resolutionLabel";
            resolutionLabel.Size = new System.Drawing.Size(57, 13);
            resolutionLabel.TabIndex = 46;
            resolutionLabel.Text = "Resolution";
            // 
            // signalPeriodLabel
            // 
            signalPeriodLabel.AutoSize = true;
            signalPeriodLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            signalPeriodLabel.Location = new System.Drawing.Point(44, 105);
            signalPeriodLabel.Name = "signalPeriodLabel";
            signalPeriodLabel.Size = new System.Drawing.Size(125, 13);
            signalPeriodLabel.TabIndex = 46;
            signalPeriodLabel.Text = "Signal period (m/period)";
            // 
            // helpLabel
            // 
            helpLabel.Location = new System.Drawing.Point(8, 16);
            helpLabel.Name = "helpLabel";
            helpLabel.Size = new System.Drawing.Size(914, 32);
            helpLabel.TabIndex = 0;
            helpLabel.Text = resources.GetString("helpLabel.Text");
            helpLabel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // readTimeValueLabel
            // 
            readTimeValueLabel.AutoSize = true;
            readTimeValueLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            readTimeValueLabel.Location = new System.Drawing.Point(47, 122);
            readTimeValueLabel.Name = "readTimeValueLabel";
            readTimeValueLabel.Size = new System.Drawing.Size(84, 13);
            readTimeValueLabel.TabIndex = 96;
            readTimeValueLabel.Text = "Read time value";
            // 
            // readSequencLabel
            // 
            readSequencLabel.AutoSize = true;
            readSequencLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            readSequencLabel.Location = new System.Drawing.Point(47, 76);
            readSequencLabel.Name = "readSequencLabel";
            readSequencLabel.Size = new System.Drawing.Size(332, 13);
            readSequencLabel.TabIndex = 88;
            readSequencLabel.Text = "Nbr of read sequences to acquire before the data are sent  (1 to 200)";
            // 
            // sequenceCounterLabel
            // 
            sequenceCounterLabel.AutoSize = true;
            sequenceCounterLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            sequenceCounterLabel.Location = new System.Drawing.Point(47, 53);
            sequenceCounterLabel.Name = "sequenceCounterLabel";
            sequenceCounterLabel.Size = new System.Drawing.Size(327, 13);
            sequenceCounterLabel.TabIndex = 86;
            sequenceCounterLabel.Text = "How many read counter (s) sequence must be run (0 for continuous)";
            // 
            // ipAddressLabel
            // 
            ipAddressLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            ipAddressLabel.Location = new System.Drawing.Point(27, 27);
            ipAddressLabel.Name = "ipAddressLabel";
            ipAddressLabel.Size = new System.Drawing.Size(208, 16);
            ipAddressLabel.TabIndex = 98;
            ipAddressLabel.Text = "IP address of the MSX-E170x module :";
            // 
            // descriptionGroupBox
            // 
            this.descriptionGroupBox.Controls.Add(descriptionLabel);
            this.descriptionGroupBox.Location = new System.Drawing.Point(8, 8);
            this.descriptionGroupBox.Name = "descriptionGroupBox";
            this.descriptionGroupBox.Size = new System.Drawing.Size(928, 48);
            this.descriptionGroupBox.TabIndex = 10;
            this.descriptionGroupBox.TabStop = false;
            this.descriptionGroupBox.Text = "Description";
            // 
            // counterConfigGroupBox
            // 
            this.counterConfigGroupBox.Controls.Add(this.gateCounter3CheckBox);
            this.counterConfigGroupBox.Controls.Add(this.gateCounter2CheckBox);
            this.counterConfigGroupBox.Controls.Add(this.gateCounter1CheckBox);
            this.counterConfigGroupBox.Controls.Add(this.gateCounter0CheckBox);
            this.counterConfigGroupBox.Controls.Add(triggerGateSelectionLabel);
            this.counterConfigGroupBox.Controls.Add(this.L_Frequency);
            this.counterConfigGroupBox.Controls.Add(this.signalPeriodTextBox);
            this.counterConfigGroupBox.Controls.Add(this.CH_Counter3);
            this.counterConfigGroupBox.Controls.Add(this.CH_Counter2);
            this.counterConfigGroupBox.Controls.Add(this.CH_Counter1);
            this.counterConfigGroupBox.Controls.Add(this.CH_Counter0);
            this.counterConfigGroupBox.Controls.Add(maxInputFrequencyLabel);
            this.counterConfigGroupBox.Controls.Add(valueFormatLabel);
            this.counterConfigGroupBox.Controls.Add(counterSelectionLabel);
            this.counterConfigGroupBox.Controls.Add(resolutionLabel);
            this.counterConfigGroupBox.Controls.Add(signalPeriodLabel);
            this.counterConfigGroupBox.Controls.Add(this.valueFormatComboBox);
            this.counterConfigGroupBox.Controls.Add(this.resolutionComboBox);
            this.counterConfigGroupBox.Location = new System.Drawing.Point(8, 194);
            this.counterConfigGroupBox.Name = "counterConfigGroupBox";
            this.counterConfigGroupBox.Size = new System.Drawing.Size(385, 190);
            this.counterConfigGroupBox.TabIndex = 76;
            this.counterConfigGroupBox.TabStop = false;
            this.counterConfigGroupBox.Text = "Counter(s) configuration";
            // 
            // gateCounter3CheckBox
            // 
            this.gateCounter3CheckBox.AutoSize = true;
            this.gateCounter3CheckBox.Checked = true;
            this.gateCounter3CheckBox.CheckState = System.Windows.Forms.CheckState.Checked;
            this.gateCounter3CheckBox.Location = new System.Drawing.Point(302, 45);
            this.gateCounter3CheckBox.Name = "gateCounter3CheckBox";
            this.gateCounter3CheckBox.Size = new System.Drawing.Size(15, 14);
            this.gateCounter3CheckBox.TabIndex = 53;
            this.gateCounter3CheckBox.UseVisualStyleBackColor = true;
            // 
            // gateCounter2CheckBox
            // 
            this.gateCounter2CheckBox.AutoSize = true;
            this.gateCounter2CheckBox.Checked = true;
            this.gateCounter2CheckBox.CheckState = System.Windows.Forms.CheckState.Checked;
            this.gateCounter2CheckBox.Location = new System.Drawing.Point(264, 45);
            this.gateCounter2CheckBox.Name = "gateCounter2CheckBox";
            this.gateCounter2CheckBox.Size = new System.Drawing.Size(15, 14);
            this.gateCounter2CheckBox.TabIndex = 52;
            this.gateCounter2CheckBox.UseVisualStyleBackColor = true;
            // 
            // gateCounter1CheckBox
            // 
            this.gateCounter1CheckBox.AutoSize = true;
            this.gateCounter1CheckBox.Checked = true;
            this.gateCounter1CheckBox.CheckState = System.Windows.Forms.CheckState.Checked;
            this.gateCounter1CheckBox.Location = new System.Drawing.Point(226, 45);
            this.gateCounter1CheckBox.Name = "gateCounter1CheckBox";
            this.gateCounter1CheckBox.Size = new System.Drawing.Size(15, 14);
            this.gateCounter1CheckBox.TabIndex = 51;
            this.gateCounter1CheckBox.UseVisualStyleBackColor = true;
            // 
            // gateCounter0CheckBox
            // 
            this.gateCounter0CheckBox.AutoSize = true;
            this.gateCounter0CheckBox.Checked = true;
            this.gateCounter0CheckBox.CheckState = System.Windows.Forms.CheckState.Checked;
            this.gateCounter0CheckBox.Location = new System.Drawing.Point(188, 45);
            this.gateCounter0CheckBox.Name = "gateCounter0CheckBox";
            this.gateCounter0CheckBox.Size = new System.Drawing.Size(15, 14);
            this.gateCounter0CheckBox.TabIndex = 50;
            this.gateCounter0CheckBox.UseVisualStyleBackColor = true;
            // 
            // L_Frequency
            // 
            this.L_Frequency.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.L_Frequency.ForeColor = System.Drawing.Color.Blue;
            this.L_Frequency.Location = new System.Drawing.Point(173, 163);
            this.L_Frequency.Name = "L_Frequency";
            this.L_Frequency.Size = new System.Drawing.Size(149, 13);
            this.L_Frequency.TabIndex = 49;
            // 
            // signalPeriodTextBox
            // 
            this.signalPeriodTextBox.Location = new System.Drawing.Point(176, 104);
            this.signalPeriodTextBox.Name = "signalPeriodTextBox";
            this.signalPeriodTextBox.Size = new System.Drawing.Size(146, 20);
            this.signalPeriodTextBox.TabIndex = 48;
            // 
            // CH_Counter3
            // 
            this.CH_Counter3.AutoSize = true;
            this.CH_Counter3.Checked = true;
            this.CH_Counter3.CheckState = System.Windows.Forms.CheckState.Checked;
            this.CH_Counter3.Location = new System.Drawing.Point(302, 22);
            this.CH_Counter3.Name = "CH_Counter3";
            this.CH_Counter3.Size = new System.Drawing.Size(32, 17);
            this.CH_Counter3.TabIndex = 7;
            this.CH_Counter3.Text = "3";
            this.CH_Counter3.UseVisualStyleBackColor = true;
            this.CH_Counter3.CheckedChanged += new System.EventHandler(this.CH_Counter_CheckedChanged);
            // 
            // CH_Counter2
            // 
            this.CH_Counter2.AutoSize = true;
            this.CH_Counter2.Checked = true;
            this.CH_Counter2.CheckState = System.Windows.Forms.CheckState.Checked;
            this.CH_Counter2.Location = new System.Drawing.Point(264, 22);
            this.CH_Counter2.Name = "CH_Counter2";
            this.CH_Counter2.Size = new System.Drawing.Size(32, 17);
            this.CH_Counter2.TabIndex = 6;
            this.CH_Counter2.Text = "2";
            this.CH_Counter2.UseVisualStyleBackColor = true;
            this.CH_Counter2.CheckedChanged += new System.EventHandler(this.CH_Counter_CheckedChanged);
            // 
            // CH_Counter1
            // 
            this.CH_Counter1.AutoSize = true;
            this.CH_Counter1.Checked = true;
            this.CH_Counter1.CheckState = System.Windows.Forms.CheckState.Checked;
            this.CH_Counter1.Location = new System.Drawing.Point(226, 22);
            this.CH_Counter1.Name = "CH_Counter1";
            this.CH_Counter1.Size = new System.Drawing.Size(32, 17);
            this.CH_Counter1.TabIndex = 5;
            this.CH_Counter1.Text = "1";
            this.CH_Counter1.UseVisualStyleBackColor = true;
            this.CH_Counter1.CheckedChanged += new System.EventHandler(this.CH_Counter_CheckedChanged);
            // 
            // CH_Counter0
            // 
            this.CH_Counter0.AutoSize = true;
            this.CH_Counter0.Checked = true;
            this.CH_Counter0.CheckState = System.Windows.Forms.CheckState.Checked;
            this.CH_Counter0.Location = new System.Drawing.Point(188, 22);
            this.CH_Counter0.Name = "CH_Counter0";
            this.CH_Counter0.Size = new System.Drawing.Size(32, 17);
            this.CH_Counter0.TabIndex = 4;
            this.CH_Counter0.Text = "0";
            this.CH_Counter0.UseVisualStyleBackColor = true;
            this.CH_Counter0.CheckedChanged += new System.EventHandler(this.CH_Counter_CheckedChanged);
            // 
            // valueFormatComboBox
            // 
            this.valueFormatComboBox.AllowDrop = true;
            this.valueFormatComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.valueFormatComboBox.FormattingEnabled = true;
            this.valueFormatComboBox.Location = new System.Drawing.Point(176, 134);
            this.valueFormatComboBox.Name = "valueFormatComboBox";
            this.valueFormatComboBox.Size = new System.Drawing.Size(146, 21);
            this.valueFormatComboBox.TabIndex = 9;
            // 
            // resolutionComboBox
            // 
            this.resolutionComboBox.AllowDrop = true;
            this.resolutionComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.resolutionComboBox.FormattingEnabled = true;
            this.resolutionComboBox.Location = new System.Drawing.Point(176, 72);
            this.resolutionComboBox.Name = "resolutionComboBox";
            this.resolutionComboBox.Size = new System.Drawing.Size(146, 21);
            this.resolutionComboBox.TabIndex = 8;
            // 
            // helpGroupBox
            // 
            this.helpGroupBox.Controls.Add(helpLabel);
            this.helpGroupBox.Location = new System.Drawing.Point(8, 62);
            this.helpGroupBox.Name = "helpGroupBox";
            this.helpGroupBox.Size = new System.Drawing.Size(928, 56);
            this.helpGroupBox.TabIndex = 93;
            this.helpGroupBox.TabStop = false;
            this.helpGroupBox.Text = "Help";
            // 
            // acquisitionConfigurationGroupBox
            // 
            this.acquisitionConfigurationGroupBox.Controls.Add(readTimeValueLabel);
            this.acquisitionConfigurationGroupBox.Controls.Add(this.readTimeBaseLabel);
            this.acquisitionConfigurationGroupBox.Controls.Add(this.LB_ReadTime);
            this.acquisitionConfigurationGroupBox.Controls.Add(this.readTimeValueTextBox);
            this.acquisitionConfigurationGroupBox.Controls.Add(this.TB_TransferNbr);
            this.acquisitionConfigurationGroupBox.Controls.Add(readSequencLabel);
            this.acquisitionConfigurationGroupBox.Controls.Add(this.TB_SequenceNbr);
            this.acquisitionConfigurationGroupBox.Controls.Add(sequenceCounterLabel);
            this.acquisitionConfigurationGroupBox.Location = new System.Drawing.Point(401, 194);
            this.acquisitionConfigurationGroupBox.Name = "acquisitionConfigurationGroupBox";
            this.acquisitionConfigurationGroupBox.Size = new System.Drawing.Size(535, 190);
            this.acquisitionConfigurationGroupBox.TabIndex = 94;
            this.acquisitionConfigurationGroupBox.TabStop = false;
            this.acquisitionConfigurationGroupBox.Text = "Acquisition configuration";
            // 
            // readTimeBaseLabel
            // 
            this.readTimeBaseLabel.AutoSize = true;
            this.readTimeBaseLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.readTimeBaseLabel.Location = new System.Drawing.Point(47, 99);
            this.readTimeBaseLabel.Name = "readTimeBaseLabel";
            this.readTimeBaseLabel.Size = new System.Drawing.Size(84, 13);
            this.readTimeBaseLabel.TabIndex = 95;
            this.readTimeBaseLabel.Text = "Read time base ";
            // 
            // LB_ReadTime
            // 
            this.LB_ReadTime.AllowDrop = true;
            this.LB_ReadTime.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.LB_ReadTime.FormattingEnabled = true;
            this.LB_ReadTime.Location = new System.Drawing.Point(396, 96);
            this.LB_ReadTime.Name = "LB_ReadTime";
            this.LB_ReadTime.Size = new System.Drawing.Size(92, 21);
            this.LB_ReadTime.TabIndex = 12;
            // 
            // readTimeValueTextBox
            // 
            this.readTimeValueTextBox.Location = new System.Drawing.Point(397, 120);
            this.readTimeValueTextBox.Name = "readTimeValueTextBox";
            this.readTimeValueTextBox.Size = new System.Drawing.Size(91, 20);
            this.readTimeValueTextBox.TabIndex = 13;
            this.readTimeValueTextBox.Text = "25";
            // 
            // TB_TransferNbr
            // 
            this.TB_TransferNbr.Location = new System.Drawing.Point(397, 73);
            this.TB_TransferNbr.Name = "TB_TransferNbr";
            this.TB_TransferNbr.Size = new System.Drawing.Size(91, 20);
            this.TB_TransferNbr.TabIndex = 11;
            this.TB_TransferNbr.Text = "10";
            // 
            // TB_SequenceNbr
            // 
            this.TB_SequenceNbr.Location = new System.Drawing.Point(397, 50);
            this.TB_SequenceNbr.Name = "TB_SequenceNbr";
            this.TB_SequenceNbr.Size = new System.Drawing.Size(91, 20);
            this.TB_SequenceNbr.TabIndex = 10;
            this.TB_SequenceNbr.Text = "100";
            // 
            // counterInitialisationButton
            // 
            this.counterInitialisationButton.Enabled = false;
            this.counterInitialisationButton.Location = new System.Drawing.Point(11, 19);
            this.counterInitialisationButton.Name = "counterInitialisationButton";
            this.counterInitialisationButton.Size = new System.Drawing.Size(352, 29);
            this.counterInitialisationButton.TabIndex = 14;
            this.counterInitialisationButton.Text = "Counter(s) initialisation";
            this.counterInitialisationButton.UseVisualStyleBackColor = true;
            this.counterInitialisationButton.Click += new System.EventHandler(this.B_CounterInitialisation_Click);
            // 
            // clearCounterButton
            // 
            this.clearCounterButton.Enabled = false;
            this.clearCounterButton.Location = new System.Drawing.Point(190, 54);
            this.clearCounterButton.Name = "clearCounterButton";
            this.clearCounterButton.Size = new System.Drawing.Size(173, 29);
            this.clearCounterButton.TabIndex = 16;
            this.clearCounterButton.Text = "Clear counter(s)";
            this.clearCounterButton.UseVisualStyleBackColor = true;
            this.clearCounterButton.Click += new System.EventHandler(this.B_ClearCounter_Click);
            // 
            // startCounterAcquisitionButton
            // 
            this.startCounterAcquisitionButton.Enabled = false;
            this.startCounterAcquisitionButton.Location = new System.Drawing.Point(269, 19);
            this.startCounterAcquisitionButton.Name = "startCounterAcquisitionButton";
            this.startCounterAcquisitionButton.Size = new System.Drawing.Size(257, 29);
            this.startCounterAcquisitionButton.TabIndex = 19;
            this.startCounterAcquisitionButton.Text = "Start cyclic acquisition";
            this.startCounterAcquisitionButton.UseVisualStyleBackColor = true;
            this.startCounterAcquisitionButton.Click += new System.EventHandler(this.B_StartCounterAcquisition_Click);
            // 
            // stopCounterAcquisitionButton
            // 
            this.stopCounterAcquisitionButton.Enabled = false;
            this.stopCounterAcquisitionButton.Location = new System.Drawing.Point(269, 52);
            this.stopCounterAcquisitionButton.Name = "stopCounterAcquisitionButton";
            this.stopCounterAcquisitionButton.Size = new System.Drawing.Size(257, 29);
            this.stopCounterAcquisitionButton.TabIndex = 20;
            this.stopCounterAcquisitionButton.Text = "Stop cyclic acquisition";
            this.stopCounterAcquisitionButton.UseVisualStyleBackColor = true;
            this.stopCounterAcquisitionButton.Click += new System.EventHandler(this.B_StopCounterAcquisition_Click);
            // 
            // counterReleaseInitialisationButton
            // 
            this.counterReleaseInitialisationButton.Enabled = false;
            this.counterReleaseInitialisationButton.Location = new System.Drawing.Point(11, 54);
            this.counterReleaseInitialisationButton.Name = "counterReleaseInitialisationButton";
            this.counterReleaseInitialisationButton.Size = new System.Drawing.Size(173, 29);
            this.counterReleaseInitialisationButton.TabIndex = 15;
            this.counterReleaseInitialisationButton.Text = "Release counter(s) initialisation";
            this.counterReleaseInitialisationButton.UseVisualStyleBackColor = true;
            this.counterReleaseInitialisationButton.Click += new System.EventHandler(this.B_CounterReleaseInitialisation_Click);
            // 
            // sequenceInformationGroupBox
            // 
            this.sequenceInformationGroupBox.Controls.Add(this.valuesTextbox);
            this.sequenceInformationGroupBox.Location = new System.Drawing.Point(8, 484);
            this.sequenceInformationGroupBox.Name = "sequenceInformationGroupBox";
            this.sequenceInformationGroupBox.Size = new System.Drawing.Size(934, 138);
            this.sequenceInformationGroupBox.TabIndex = 99;
            this.sequenceInformationGroupBox.TabStop = false;
            this.sequenceInformationGroupBox.Text = "Sequence information";
            // 
            // valuesTextbox
            // 
            this.valuesTextbox.Font = new System.Drawing.Font("Courier New", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.valuesTextbox.Location = new System.Drawing.Point(11, 19);
            this.valuesTextbox.Multiline = true;
            this.valuesTextbox.Name = "valuesTextbox";
            this.valuesTextbox.ReadOnly = true;
            this.valuesTextbox.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.valuesTextbox.Size = new System.Drawing.Size(917, 107);
            this.valuesTextbox.TabIndex = 140;
            this.valuesTextbox.TabStop = false;
            // 
            // DisplayTimer
            // 
            this.DisplayTimer.Interval = 1;
            this.DisplayTimer.Tick += new System.EventHandler(this.DisplayTimer_Tick);
            // 
            // moduleSelectionGroupBox
            // 
            this.moduleSelectionGroupBox.Controls.Add(this.L_MSXEInfo);
            this.moduleSelectionGroupBox.Controls.Add(this.connectButton);
            this.moduleSelectionGroupBox.Controls.Add(this.label3);
            this.moduleSelectionGroupBox.Controls.Add(this.label4);
            this.moduleSelectionGroupBox.Controls.Add(this.label5);
            this.moduleSelectionGroupBox.Controls.Add(this.IP3Textbox);
            this.moduleSelectionGroupBox.Controls.Add(this.IP2Textbox);
            this.moduleSelectionGroupBox.Controls.Add(this.IP1Textbox);
            this.moduleSelectionGroupBox.Controls.Add(this.IP0Textbox);
            this.moduleSelectionGroupBox.Controls.Add(ipAddressLabel);
            this.moduleSelectionGroupBox.Location = new System.Drawing.Point(8, 130);
            this.moduleSelectionGroupBox.Name = "moduleSelectionGroupBox";
            this.moduleSelectionGroupBox.Size = new System.Drawing.Size(928, 58);
            this.moduleSelectionGroupBox.TabIndex = 100;
            this.moduleSelectionGroupBox.TabStop = false;
            this.moduleSelectionGroupBox.Text = "Module selection";
            // 
            // L_MSXEInfo
            // 
            this.L_MSXEInfo.Location = new System.Drawing.Point(544, 13);
            this.L_MSXEInfo.Name = "L_MSXEInfo";
            this.L_MSXEInfo.Size = new System.Drawing.Size(378, 36);
            this.L_MSXEInfo.TabIndex = 102;
            this.L_MSXEInfo.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // connectButton
            // 
            this.connectButton.Location = new System.Drawing.Point(447, 20);
            this.connectButton.Name = "connectButton";
            this.connectButton.Size = new System.Drawing.Size(91, 29);
            this.connectButton.TabIndex = 97;
            this.connectButton.Text = "Connect";
            this.connectButton.UseVisualStyleBackColor = true;
            this.connectButton.Click += new System.EventHandler(this.B_Connect_Click);
            // 
            // label3
            // 
            this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label3.Location = new System.Drawing.Point(393, 25);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(8, 16);
            this.label3.TabIndex = 101;
            this.label3.Text = "-";
            // 
            // label4
            // 
            this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label4.Location = new System.Drawing.Point(337, 25);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(8, 16);
            this.label4.TabIndex = 100;
            this.label4.Text = "-";
            // 
            // label5
            // 
            this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label5.Location = new System.Drawing.Point(281, 25);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(8, 16);
            this.label5.TabIndex = 99;
            this.label5.Text = "-";
            // 
            // IP3Textbox
            // 
            this.IP3Textbox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.IP3Textbox.Location = new System.Drawing.Point(409, 25);
            this.IP3Textbox.MaxLength = 3;
            this.IP3Textbox.Name = "IP3Textbox";
            this.IP3Textbox.Size = new System.Drawing.Size(32, 20);
            this.IP3Textbox.TabIndex = 96;
            // 
            // IP2Textbox
            // 
            this.IP2Textbox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.IP2Textbox.Location = new System.Drawing.Point(353, 25);
            this.IP2Textbox.MaxLength = 3;
            this.IP2Textbox.Name = "IP2Textbox";
            this.IP2Textbox.Size = new System.Drawing.Size(32, 20);
            this.IP2Textbox.TabIndex = 95;
            // 
            // IP1Textbox
            // 
            this.IP1Textbox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.IP1Textbox.Location = new System.Drawing.Point(297, 25);
            this.IP1Textbox.MaxLength = 3;
            this.IP1Textbox.Name = "IP1Textbox";
            this.IP1Textbox.Size = new System.Drawing.Size(32, 20);
            this.IP1Textbox.TabIndex = 94;
            // 
            // IP0Textbox
            // 
            this.IP0Textbox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.IP0Textbox.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.IP0Textbox.Location = new System.Drawing.Point(241, 25);
            this.IP0Textbox.MaxLength = 3;
            this.IP0Textbox.Name = "IP0Textbox";
            this.IP0Textbox.Size = new System.Drawing.Size(32, 20);
            this.IP0Textbox.TabIndex = 93;
            // 
            // disableGateButton
            // 
            this.disableGateButton.Enabled = false;
            this.disableGateButton.Location = new System.Drawing.Point(6, 52);
            this.disableGateButton.Name = "disableGateButton";
            this.disableGateButton.Size = new System.Drawing.Size(257, 29);
            this.disableGateButton.TabIndex = 20;
            this.disableGateButton.Text = "Disable gate";
            this.disableGateButton.UseVisualStyleBackColor = true;
            this.disableGateButton.Click += new System.EventHandler(this.enableDisableGateButton_Click);
            // 
            // enableGateButton
            // 
            this.enableGateButton.Enabled = false;
            this.enableGateButton.Location = new System.Drawing.Point(6, 19);
            this.enableGateButton.Name = "enableGateButton";
            this.enableGateButton.Size = new System.Drawing.Size(257, 29);
            this.enableGateButton.TabIndex = 20;
            this.enableGateButton.Text = "Enable gate";
            this.enableGateButton.UseVisualStyleBackColor = true;
            this.enableGateButton.Click += new System.EventHandler(this.enableDisableGateButton_Click);
            // 
            // controlsGroupBox
            // 
            this.controlsGroupBox.Controls.Add(this.enableGateButton);
            this.controlsGroupBox.Controls.Add(this.startCounterAcquisitionButton);
            this.controlsGroupBox.Controls.Add(this.stopCounterAcquisitionButton);
            this.controlsGroupBox.Controls.Add(this.disableGateButton);
            this.controlsGroupBox.Location = new System.Drawing.Point(404, 390);
            this.controlsGroupBox.Name = "controlsGroupBox";
            this.controlsGroupBox.Size = new System.Drawing.Size(532, 88);
            this.controlsGroupBox.TabIndex = 101;
            this.controlsGroupBox.TabStop = false;
            this.controlsGroupBox.Text = "Controls";
            // 
            // counterGroupBox
            // 
            this.counterGroupBox.Controls.Add(this.counterReleaseInitialisationButton);
            this.counterGroupBox.Controls.Add(this.counterInitialisationButton);
            this.counterGroupBox.Controls.Add(this.clearCounterButton);
            this.counterGroupBox.Location = new System.Drawing.Point(8, 390);
            this.counterGroupBox.Name = "counterGroupBox";
            this.counterGroupBox.Size = new System.Drawing.Size(385, 88);
            this.counterGroupBox.TabIndex = 102;
            this.counterGroupBox.TabStop = false;
            this.counterGroupBox.Text = "Counter controls";
            // 
            // CyclicAcquisitionHWTriggerGate
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(954, 632);
            this.Controls.Add(this.counterGroupBox);
            this.Controls.Add(this.controlsGroupBox);
            this.Controls.Add(this.moduleSelectionGroupBox);
            this.Controls.Add(this.sequenceInformationGroupBox);
            this.Controls.Add(this.acquisitionConfigurationGroupBox);
            this.Controls.Add(this.helpGroupBox);
            this.Controls.Add(this.counterConfigGroupBox);
            this.Controls.Add(this.descriptionGroupBox);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "CyclicAcquisitionHWTriggerGate";
            this.Text = "C# Counter(s) cyclic acquisition with Hardware Trigger Gate";
            this.Load += new System.EventHandler(this.CyclicAcquisitionHWTriggerGate_Load);
            this.Closed += new System.EventHandler(this.CyclicAcquisitionHWTriggerGate_Closed);
            this.FormClosed += new System.Windows.Forms.FormClosedEventHandler(this.CyclicAcquisitionHWTriggerGate_FormClosed);
            this.descriptionGroupBox.ResumeLayout(false);
            this.counterConfigGroupBox.ResumeLayout(false);
            this.counterConfigGroupBox.PerformLayout();
            this.helpGroupBox.ResumeLayout(false);
            this.acquisitionConfigurationGroupBox.ResumeLayout(false);
            this.acquisitionConfigurationGroupBox.PerformLayout();
            this.sequenceInformationGroupBox.ResumeLayout(false);
            this.sequenceInformationGroupBox.PerformLayout();
            this.moduleSelectionGroupBox.ResumeLayout(false);
            this.moduleSelectionGroupBox.PerformLayout();
            this.controlsGroupBox.ResumeLayout(false);
            this.counterGroupBox.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
            Application.Run(new CyclicAcquisitionHWTriggerGate());
		}

        public static String ConvertFromTime_T(byte[] bBuffer, int iIndex)
        {
            ulong ulTimeStampLow = BitConverter.ToUInt32(bBuffer, iIndex);
            ulong ulTimeStampHigh = BitConverter.ToUInt32(bBuffer, iIndex + 4);

            return (ConvertFromTime_T(ulTimeStampHigh, ulTimeStampLow));
        }

        public static String ConvertFromTime_T(ulong ulTimeStampHigh, ulong ulTimeStampLow)
        {
            ulong ulTimeStampLowms = (ulong)(ulTimeStampLow / 1000);
            ulong ulTimeStampLowmus = (ulong)(ulTimeStampLow % 1000);

            DateTime dt70 = new DateTime(1970, 1, 1, 0, 0, 0, 0);
            long tickTotal = dt70.Ticks + (long)(ulTimeStampHigh * 10000000L);
            DateTime netTimeT = new DateTime(tickTotal);
            return (netTimeT.ToString() + "." + ulTimeStampLowms.ToString("D3") + "." + ulTimeStampLowmus.ToString("D3"));
        }
        
        
        // Global Variable
		MXCommon_WebReference.MXCommon MX_Common;
		MSXE171x_WebReference.MSXE17xx MSXE17xx;
        Socket                         SocketClient = null;
        String                         DisplayText = "";
        AsyncClientStream              Client = null;
        CheckBox[]                     CounterList;
        int                            Counters = 0;
        byte                           bValueFormat = 0;

        private void CyclicAcquisitionHWTriggerGate_Load(object sender, System.EventArgs e)
		{
			MX_Common = new MXCommon_WebReference.MXCommon();
            MSXE17xx  = new MSXE171x_WebReference.MSXE17xx();
			MX_Common.Timeout = 2000;
            MSXE17xx.Timeout = 2000;

            IP0Textbox.Text = Properties.Settings.Default.IP0Textbox;
            IP1Textbox.Text = Properties.Settings.Default.IP1Textbox;
            IP2Textbox.Text = Properties.Settings.Default.IP2Textbox;
            IP3Textbox.Text = Properties.Settings.Default.IP3Textbox;

            ArrayList Resolution = new ArrayList();
            Resolution.Add(new ListData("16", 16));
            Resolution.Add(new ListData("32", 32));
            Resolution.Add(new ListData("40", 40));
            Resolution.Add(new ListData("64", 64));
            Resolution.Add(new ListData("80", 80));
            Resolution.Add(new ListData("100", 100));
            Resolution.Add(new ListData("128", 128));
            Resolution.Add(new ListData("160", 160));
            Resolution.Add(new ListData("200", 200));
            Resolution.Add(new ListData("256", 256));
            Resolution.Add(new ListData("320", 320));
            Resolution.Add(new ListData("400", 400));
            Resolution.Add(new ListData("500", 500));
            Resolution.Add(new ListData("512", 512));
            Resolution.Add(new ListData("800", 800));
            Resolution.Add(new ListData("1000", 1000));
            Resolution.Add(new ListData("1024", 1024));
            Resolution.Add(new ListData("1600", 1600));
            Resolution.Add(new ListData("2000", 2000));
            Resolution.Add(new ListData("2048", 2048));
            Resolution.Add(new ListData("4096", 4096));
            Resolution.Add(new ListData("8192", 8192));

            resolutionComboBox.DataSource = Resolution;
            resolutionComboBox.DisplayMember = "Item";
            resolutionComboBox.ValueMember = "Value";
            resolutionComboBox.SelectedIndex = Properties.Settings.Default.resolutionComboBox;

            // Counter data format list box initialisation
            ArrayList ValueFormat = new ArrayList();
            ValueFormat.Add(new ListData("Raw data", 0));
            ValueFormat.Add(new ListData("Millimeters", 1));

            valueFormatComboBox.DataSource = ValueFormat;
            valueFormatComboBox.DisplayMember = "Item";
            valueFormatComboBox.ValueMember = "Value";
            valueFormatComboBox.SelectedIndex = Properties.Settings.Default.valueFormatComboBox;

            signalPeriodTextBox.Text = Properties.Settings.Default.signalPeriodTextBox;

            // Read time list box initialisation
            ArrayList ReadTimes = new ArrayList();
            ReadTimes.Add(new ListData("s", 0));
            ReadTimes.Add(new ListData("ms", 1));
            ReadTimes.Add(new ListData("s", 2));

            LB_ReadTime.DisplayMember = "Item";
            LB_ReadTime.ValueMember = "Value";
            LB_ReadTime.DataSource = ReadTimes;

            // Counter list initialisation
            CounterList = new CheckBox[4];
            CounterList[0] = CH_Counter0;
            CounterList[1] = CH_Counter1;
            CounterList[2] = CH_Counter2;
            CounterList[3] = CH_Counter3;
        }


        private void CyclicAcquisitionHWTriggerGate_Closed(object sender, System.EventArgs e)
		{
            CloseAll();

            if (MSXE17xx != null)
			{
                MSXE17xx = null;
			}
			if (MX_Common != null)
			{
				MX_Common = null;
			}

			System.GC.Collect();
		}

        private void CloseAll ()
        {
            // Test if any acquisition in progress
            if (stopCounterAcquisitionButton.Enabled == true)
            {
                // Test the current acquisition
                B_StopCounterAcquisition_Click(null, null);
            }

            // Test if counter initialised
            if (counterReleaseInitialisationButton.Enabled == true)
            {
                // Release the counter initialisation
                B_CounterReleaseInitialisation_Click(null, null);
            }
        }

        private void B_Connect_Click(object sender, EventArgs e)
        {
            byte[] bModuleType = new byte[200];
            System.Text.ASCIIEncoding ASCIIEnc = new System.Text.ASCIIEncoding();

            if ((IP0Textbox.Text.ToString() == "") || (IP1Textbox.Text.ToString() == "") || (IP2Textbox.Text.ToString() == "") || (IP3Textbox.Text.ToString() == ""))
            {
                MessageBox.Show("The IP address you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                if ((Convert.ToUInt64(IP0Textbox.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(IP0Textbox.Text.ToString(), 10) < 256))
                {
                    if ((Convert.ToUInt64(IP1Textbox.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(IP1Textbox.Text.ToString(), 10) < 256))
                    {
                        if ((Convert.ToUInt64(IP2Textbox.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(IP2Textbox.Text.ToString(), 10) < 256))
                        {
                            if ((Convert.ToUInt64(IP3Textbox.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(IP3Textbox.Text.ToString(), 10) < 256))
                            {
                                CloseAll();

                                try
                                {
                                    MSXE17xx.Url = "http://" + IP0Textbox.Text + "." + IP1Textbox.Text + "." + IP2Textbox.Text + "." + IP3Textbox.Text + ":5555";
                                    MX_Common.Url = MSXE17xx.Url;

                                    // Get the module type
                                    MX_Common.GetModuleType(out bModuleType);
                                    L_MSXEInfo.Text = ASCIIEnc.GetString(bModuleType);

                                    // Button initialisation
                                    counterInitialisationButton.Enabled = true;
                                    counterReleaseInitialisationButton.Enabled = false;
                                    clearCounterButton.Enabled = false;
                                    startCounterAcquisitionButton.Enabled = false;
                                    stopCounterAcquisitionButton.Enabled = false;
                                    counterConfigGroupBox.Enabled = true;
                                    acquisitionConfigurationGroupBox.Enabled = true;
                                }
                                catch (Exception ex)
                                {
                                    MessageBox.Show("SOAP connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                }
                            }
                            else
                            {
                                MessageBox.Show("The IP address (part 4) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                        }
                        else
                        {
                            MessageBox.Show("The IP address (part 3) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        }
                    }
                    else
                    {
                        MessageBox.Show("The IP address (part 2) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
                else
                {
                    MessageBox.Show("The IP address (part 1) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }
        }

        private void B_CounterInitialisation_Click(object sender, EventArgs e)
        {
            int   syserno             = 0;
            bool  boErrorOccur        = false;
            ulong ulInfo1             = 0;
            ulong ulInfo2             = 0;
            ulong ulMaxInputFrequency = 0;
            double dSiagnalPeriod     = 0.0;
            MSXE171x_WebReference.DefaultResponse  Response = new MSXE171x_WebReference.DefaultResponse();

            Counters = 0;

            try
            {
                dSiagnalPeriod = Convert.ToDouble(signalPeriodTextBox.Text);
            }
            catch 
            {
                MessageBox.Show("Invalid format.", "Signal period", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            // Counter(s) initialisation
            for (ulong i = 0; (i < 4) && (boErrorOccur == false); i++)
            {
                // Test if counter used
                if (CounterList[i].Checked == true)
                {
                    try
                    {
                        bValueFormat = Convert.ToByte(valueFormatComboBox.SelectedValue);

                        // Init the counter
                        Response = MSXE17xx.MFSinCosInitEx(i, 
                                                           1,
                                                           dSiagnalPeriod,
                                                           Convert.ToUInt32(resolutionComboBox.SelectedValue),
                                                           Convert.ToUInt32(valueFormatComboBox.SelectedValue), 
                                                           0, 
                                                           0, 
                                                           0, 
                                                           0, 
                                                           out ulMaxInputFrequency, 
                                                           out ulInfo1, 
                                                           out ulInfo2);

                        if (Response.iReturnValue != 0)
                        {
                            boErrorOccur = true;
                            MessageBox.Show("MFSinCosInitEx Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

                            // Test if any counter already initialised
                            if (Counters != 0)
                            {
                                for (ulong j = 0; j < i; j++)
                                {
                                    // Test if counter used
                                    if (CounterList[j].Enabled == true)
                                    {
                                        MSXE17xx.MFSinCosRelease(j, 0, 0, out syserno);
                                    }
                                }
                            }
                        }
                        else
                        {
                            Counters = Counters + 1;
                            L_Frequency.Text = ulMaxInputFrequency.ToString() + " Hz";
                        }
                    }

                    catch (Exception ex)
                    {
                        boErrorOccur = true;
                        MessageBox.Show("SOAP connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
            }

            // Test if no counter selected
            if ((Counters == 0) && (boErrorOccur == false))
            {
                MessageBox.Show("No counter(s) selected", "Configuration error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else if (boErrorOccur == false)
            {
                // Button initialisation
                counterInitialisationButton.Enabled = false;
                counterReleaseInitialisationButton.Enabled = true;
                clearCounterButton.Enabled = true;
                startCounterAcquisitionButton.Enabled = true;
                stopCounterAcquisitionButton.Enabled = false;
                enableGateButton.Enabled = true;
                disableGateButton.Enabled = true;
                counterConfigGroupBox.Enabled = false;
                acquisitionConfigurationGroupBox.Enabled = true;
            }
        }

        private void B_CounterReleaseInitialisation_Click(object sender, EventArgs e)
        {
            int syserno = 0;
            int RetValue = 0;

            // Counter(s) release
            for (ulong i = 0; i < 4; i++)
            {
                // Test if counter used
                if (CounterList[i].Checked == true)
                {
                    // Release the counter initialisation
                    RetValue = MSXE17xx.MFSinCosRelease(i, 0, 0, out syserno);

                    // Init the counter
                    if (RetValue != 0)
                    {
                        MessageBox.Show("MFSinCosRelease Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
            }

            // Button initialisation
            counterInitialisationButton.Enabled = true;
            counterReleaseInitialisationButton.Enabled = false;
            clearCounterButton.Enabled = false;
            startCounterAcquisitionButton.Enabled = false;
            stopCounterAcquisitionButton.Enabled = false;
            counterConfigGroupBox.Enabled = true;
            acquisitionConfigurationGroupBox.Enabled = true;
            enableGateButton.Enabled = false;
            disableGateButton.Enabled = false;
        }

        private void B_ClearCounter_Click(object sender, EventArgs e)
        {
            int syserno = 0;
            int RetValue = 0;

            // Clear counter(s)
            for (ulong i = 0; i < 4; i++)
            {
                // Test if counter used
                if (CounterList[i].Checked == true)
                {
                    // Clear the counter 
                    RetValue = MSXE17xx.MFSinCosClear(i, 0, 0, out syserno);

                    if (RetValue != 0)
                    {
                        MessageBox.Show("MFSinCosClear Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
            }
        }

        private void B_StartCounterAcquisition_Click(object sender, EventArgs e)
        {
            ulong FIFOSize    = Convert.ToUInt32(TB_TransferNbr.Text);
            ulong SequenceNbr = Convert.ToUInt32(TB_SequenceNbr.Text);
            int syserno = 0;
            int RetValue = 0;
            bool boErrorOccur = false;
            Thread ClientThread;

            // Test the FIFO size
            if (FIFOSize >= 1 && FIFOSize <= 200)
            {
                if ((SequenceNbr < FIFOSize) && (SequenceNbr != 0))
                {
                    MessageBox.Show("Number of read sequence to acquire > total read sequence number", "Configuration error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
                }

                // Create the client stream
                Client = new AddiData.ADDISocket.AsyncClientStream();

                // Open the socket connection to receive the data
                SocketClient = null;
                SocketClient = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
                SocketClient.ReceiveBufferSize = 1048576;
                SocketClient.Connect(IP0Textbox.Text + "." + IP1Textbox.Text + "." + IP2Textbox.Text + "." + IP3Textbox.Text, 8989);

                // Start the read socket and the user thread
                Client.SingleFramesSize = 5 * 4 * Counters;
                Client.NbrOfFrames = Convert.ToInt32(FIFOSize);
                Client.Start(SocketClient);
                ClientThread = new Thread(ClientThreadFct);
                DisplayText = "";

                MSXE17xx.MFCommonEnableDisableTriggerGate(0, 0, 0, out syserno);

                // Counter(s) synchro latch initialisation
                for (ulong i = 0; (i < 4) && (boErrorOccur == false); i++)
                {
                    // Test if counter used
                    if (CounterList[i].Checked == true)
                    {
                        // Counter FIFO initialisation
                        RetValue = MSXE17xx.MFCommonSetFIFO0Level(i, FIFOSize, 0, 0, 0, 0, out syserno);

                        if (RetValue != 0)
                        {
                            MessageBox.Show("MFCommonSetFIFO0Level Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            boErrorOccur = true;
                        }
                        else
                        {
                            // Init hardware trigger
                            MSXE17xx.MFSinCosReleaseHardwareTrigger(i, 0, out syserno);
                            RetValue = MSXE17xx.MFSinCosInitHardwareTrigger(i, 1, 1, ((CheckBox)Controls.Find("gateCounter" + i + "CheckBox", true)[0]).Checked ? (ulong)1 : (ulong)0, 0, out syserno);
                            if (RetValue != 0)
                            {
                                boErrorOccur = true;
                                MessageBox.Show("MFSinCosReleaseHardwareTrigger Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }

                            // Init the counter synchro latch
                            RetValue = MSXE17xx.MFSinCosInitAndEnableLatch(i, 1, 0, 1, 0, 0, out syserno);

                            if (RetValue != 0)
                            {
                                boErrorOccur = true;
                                MessageBox.Show("MFSinCosInitAndEnableLatch Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                        }

                        if (boErrorOccur == true)
                        {
                            for (ulong j = 0; j < i; j++)
                            {
                                // Test if counter used
                                if (CounterList[j].Enabled == true)
                                {
                                    MSXE17xx.MFSinCosDisableAndReleaseLatch(j, 1, 0, out syserno);
                                }
                            }
                        }
                    }
                }


                // Test if no error occur
                if (boErrorOccur == false)
                {
                    // Start the display timer and read socket thread
                    DisplayTimer.Enabled = true;
                    ClientThread.Priority = ThreadPriority.Lowest;
                    ClientThread.Start();

                    // Button initialisation
                    counterInitialisationButton.Enabled = false;
                    counterReleaseInitialisationButton.Enabled = false;
                    clearCounterButton.Enabled = true;
                    startCounterAcquisitionButton.Enabled = false;
                    stopCounterAcquisitionButton.Enabled = true;
                    counterConfigGroupBox.Enabled = false;
                    acquisitionConfigurationGroupBox.Enabled = false;
                }

                // Test if error occur
                if (boErrorOccur == true)
                {
                    // Stop the data server 
                    Client.Stoop();

                    try
                    {
                        // Close the socket connection
                        SocketClient.Shutdown(SocketShutdown.Both);
                        SocketClient.Close();
                        SocketClient = null;
                        System.GC.Collect();
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show("Socket close connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
            }
            else
            {
                MessageBox.Show("Number of read sequence to acquire not OK", "Configuration error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        private void B_StopCounterAcquisition_Click(object sender, EventArgs e)
        {
            int syserno = 0;
            int RetValue = 0;

            // Stop the data server 
            Client.Stoop();

            try
            {
                // Close the socket connection
                SocketClient.Shutdown(SocketShutdown.Both);
                SocketClient.Close();
                SocketClient = null;
                System.GC.Collect();
            }
            catch (Exception ex)
            {
                MessageBox.Show("Socket close connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

            // Disable synchro latch from counter(s)
            for (ulong i = 0; i < 4; i++)
            {
                // Test if counter used
                if (CounterList[i].Checked == true)
                {
                    // Disable the syncho latch
                    RetValue = MSXE17xx.MFSinCosDisableAndReleaseLatch(i, 1, 0, out syserno);

                    if (RetValue != 0)
                    {
                        MessageBox.Show("MFSinCosDisableAndReleaseLatch Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
            }

            // Button initialisation
            counterInitialisationButton.Enabled = false;
            counterReleaseInitialisationButton.Enabled = true;
            clearCounterButton.Enabled = true;
            startCounterAcquisitionButton.Enabled = true;
            stopCounterAcquisitionButton.Enabled = false;
            counterConfigGroupBox.Enabled = false;
            acquisitionConfigurationGroupBox.Enabled = true;
        }

        private void ClientThreadFct()
        {
            byte[] SocketData;
            int StreamCounter = 0;
            int Offset = 0;
            int Counter = 0;
            ulong Source = 0;
            ulong AcquisitionCounter = 0;
            String sOutString;
            Single fValue;

            while ((SocketData = Client.ReadData()) != null)
            {
                sOutString = "";
                Offset = 0;

                for (StreamCounter = 0; StreamCounter < Client.NbrOfFrames; StreamCounter++)
                {
                    for (Counter = 0; Counter < Counters; Counter++)
                    {
                        Offset = (StreamCounter + (Client.NbrOfFrames * Counter)) * 5 * 4;
                        // 
                        sOutString = sOutString + "Acquisition counter: " + AcquisitionCounter.ToString();

                        // Get the time stamp
                        sOutString = sOutString + " / Time stamp: " + ConvertFromTime_T(SocketData, Offset);
                        Offset = Offset + 8;

                        // Get the counter nbr
                        sOutString = sOutString + " / counter: " + (BitConverter.ToUInt32(SocketData, Offset) & 3).ToString();
                        Offset = Offset + 4;

                        // Get the source
                        Source = BitConverter.ToUInt32(SocketData, Offset);
                        sOutString = sOutString + " / source: " + (Source & 0x7FFFFFFFUL).ToString();
                        Offset = Offset + 4;

                        // Get the counter value
                        if (bValueFormat == 0)
                        {
                            sOutString = sOutString + " / value: " + BitConverter.ToUInt32(SocketData, Offset).ToString();
                        }
                        else
                        {
                            fValue = BitConverter.ToSingle(SocketData, Offset);

                            if (Math.Abs(fValue) < 0.0001)
                            {
                                if (Math.Abs(fValue) < 0.0000001)
                                {
                                    sOutString = sOutString + " / position: " + (fValue * 1000000.0).ToString("F3") + "nm";
                                }
                                else
                                {
                                    sOutString = sOutString + " / position: " + (fValue * 1000.0).ToString("F3") + "m";
                                }
                            }
                            else
                            {
                                sOutString = sOutString + " / position: " + fValue.ToString("F3") + "mm";
                            }
                        }

                        // Test if measure error occur
                        sOutString = sOutString + " / error: " + (Source >> 31).ToString() + Environment.NewLine;

                        AcquisitionCounter++;
                    }
                }

                DisplayText = DisplayText + sOutString;
            }
        }

        private void DisplayTimer_Tick(object sender, EventArgs e)
        {
            valuesTextbox.Text = DisplayText;
        }

        private void CH_Counter_CheckedChanged(object sender, EventArgs e)
        {
            CheckBox checkBox = sender as CheckBox;
            ((CheckBox)Controls.Find("gateCounter" + Regex.Match(checkBox.Name, @"\d+").Value + "checkBox", true)[0]).Enabled = (checkBox.Checked) ? true : false;
        }

        private void enableDisableGateButton_Click(object sender, EventArgs e)
        {
            int syserrno;
            int returnValue = 0;

            try
            {
                if ((sender as Button).Name.Contains("enable"))
                    returnValue = MSXE17xx.MFCommonEnableDisableTriggerGate(1, 0, 0, out syserrno);
                else
                    returnValue = MSXE17xx.MFCommonEnableDisableTriggerGate(0, 0, 0, out syserrno);
                if ((returnValue != 0) || (syserrno != 0))
                    throw new Exception("MFCommonEnableDisableTrig gerGate error : " + returnValue.ToString() + ", syserrno " + syserrno.ToString());
            }
            catch (Exception ex)
            {
                MessageBox.Show("enableDisableGateButton_Click Exception : " + ex.Message);
            }
        }

        private void CyclicAcquisitionHWTriggerGate_FormClosed(object sender, FormClosedEventArgs e)
        {
            Properties.Settings.Default.IP0Textbox = IP0Textbox.Text;
            Properties.Settings.Default.IP1Textbox = IP1Textbox.Text;
            Properties.Settings.Default.IP2Textbox = IP2Textbox.Text;
            Properties.Settings.Default.IP3Textbox = IP3Textbox.Text;

            Properties.Settings.Default.valueFormatComboBox = valueFormatComboBox.SelectedIndex;
            Properties.Settings.Default.resolutionComboBox = resolutionComboBox.SelectedIndex;
            Properties.Settings.Default.signalPeriodTextBox = signalPeriodTextBox.Text;
            Properties.Settings.Default.Save();
        }
    }
}
