using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace InitReadClear
{
    public partial class InitReadClear : Form
    {
        public MXCommon_WebReference.MXCommon MX_Global;
        public MSXE172x_WebReference.MSXE17xx MSXE17xx;
        public MSXE172x_WebReference.DefaultResponse Response;
        public System.UInt64 ulCounterValueFormat;


        public InitReadClear()
        {
            InitializeComponent();
        }

        private void buttonInitAndStart_Click(object sender, EventArgs e)
        {
            System.UInt64 ulCounterIndex = 0;
            System.UInt64 ulCounterMode = 0;
            System.UInt64 ulCounterSignalPeriode = 0;
            System.UInt64 ulCounterResolution = 0;            
            System.UInt64 ulCounterMaxInputFrequency = 0;
            MSXE172x_WebReference.DefaultResponse Response;
            ulCounterValueFormat = 0;

            if ((TB_IPAddress_0.Text.ToString() == "") || 
                (TB_IPAddress_1.Text.ToString() == "") || 
                (TB_IPAddress_2.Text.ToString() == "") || 
                (TB_IPAddress_3.Text.ToString() == ""))
            {
                MessageBox.Show("The IP address you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                if ((Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) < 256))
                {
                    if ((Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) < 256))
                    {
                        if ((Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) < 256))
                        {
                            if ((Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) < 256))
                            {
                                MX_Global.Url = "http://" + TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." +
                                                TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text + ":5555";

                                MSXE17xx.Url = MX_Global.Url;

                                ulCounterIndex = Convert.ToUInt64(comboBoxCounterIndex.SelectedIndex);

                                switch (comboBoxCounterMode.SelectedIndex)
                                {
                                    case 0: /* Fast mode */
                                        ulCounterMode = 0;
                                        break;
                                    case 1: /* Full range mode */
                                        ulCounterMode = 1;
                                        break;
                                }

                                ulCounterSignalPeriode = Convert.ToUInt64(textBoxSignalPeriode.Text.ToString(), 10);
                                ulCounterResolution = Convert.ToUInt64(textBoxResolution.Text.ToString(), 10);
                                ulCounterValueFormat = Convert.ToUInt64(comboBoxValueFormat.SelectedIndex);

                                try
                                {
                                   Response = MSXE17xx.MFSinCosInit(ulCounterIndex, 
                                                                    ulCounterMode, 
                                                                    ulCounterSignalPeriode,
                                                                    ulCounterResolution,
                                                                    ulCounterValueFormat,
                                                                    0, 0, 0, 0, 
                                                                    out ulCounterMaxInputFrequency);
                                   if (Response.iReturnValue != 0)
                                    {
                                       MessageBox.Show("MFSinCosInit Error : " + Response.iReturnValue.ToString() + " syserrno: " + s_GetSysErrnoString(Response.syserrno), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);                                       
                                    }
                                    else
                                   {
                                        buttonInitAndStart.Enabled = false;
                                        groupBoxCounterInit.Enabled = false;
                                        buttonClear.Enabled = true;
                                        buttonStopAndRelease.Enabled = true;
                                        timer1.Enabled = true;
                                        labelValue.Visible = true;
                                        labelError.Visible = true;
                                        labelMaxInputFrequency.Visible = true;
                                        textBoxSignalPeriode.Enabled = true;

                                        labelMaxInputFrequency.Text = "Counter max. input frequency: " + ulCounterMaxInputFrequency.ToString() + " Hz";
                                    }
                                }
                                catch (Exception ex)
                                {
                                    MessageBox.Show("MFSinCosInit Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                }

                            }
                            else
                            {
                                MessageBox.Show("The IP address (part 4) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                        }
                        else
                        {
                            MessageBox.Show("The IP address (part 3) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        }
                    }
                    else
                    {
                        MessageBox.Show("The IP address (part 2) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
                else
                {
                    MessageBox.Show("The IP address (part 1) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }
        }

        private void TB_IPAddress_0_Enter(object sender, EventArgs e)
        {
            TB_IPAddress_0.SelectAll();
        }

        private void TB_IPAddress_1_Enter(object sender, EventArgs e)
        {
            TB_IPAddress_1.SelectAll();
        }

        private void TB_IPAddress_2_Enter(object sender, EventArgs e)
        {
            TB_IPAddress_2.SelectAll();
        }

        private void TB_IPAddress_3_Enter(object sender, EventArgs e)
        {
            TB_IPAddress_3.SelectAll();
        }

        private string s_GetSysErrnoString(int isyserrno)
        {
            byte[] pb_Errno;
            MXCommon_WebReference.DefaultResponse dResponse;
            System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();

            dResponse = MX_Global.Strerror(isyserrno, out pb_Errno);
            if (dResponse.iReturnValue == 0)
                return (enc.GetString(pb_Errno));
            else
                return ("unknown error");
        }

        private void buttonClear_Click(object sender, EventArgs e)
        {
            int i_Error = 0;
            int syserrno = 0;
            System.UInt64 ulCounterIndex = 0;

            ulCounterIndex = Convert.ToUInt64(comboBoxCounterIndex.SelectedIndex);

            try
            {
                i_Error = MSXE17xx.MFSinCosClear(ulCounterIndex, 0, 0, out syserrno);
                if (i_Error != 0)
                {
                    MessageBox.Show("MFSinCosClear Error : " + i_Error.ToString() + " syserrno: " + s_GetSysErrnoString(syserrno), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("MFSinCosClear Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        private void buttonStopAndRelease_Click(object sender, EventArgs e)
        {
            System.UInt64 ulCounterIndex = 0;
            int syserrno = 0;
            int i_Error = 0;

            if (buttonStopAndRelease.Enabled == true)
            {
                ulCounterIndex = Convert.ToUInt64(comboBoxCounterIndex.SelectedIndex);

                try
                {
                    i_Error = MSXE17xx.MFSinCosRelease(ulCounterIndex, 0, 0, out syserrno);
                    if (i_Error != 0)
                    {
                        MessageBox.Show("MFSinCosRelease Error : " + i_Error.ToString() + " syserrno: " + s_GetSysErrnoString(syserrno), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                    else
                    {
                        buttonClear.Enabled = false;
                        buttonStopAndRelease.Enabled = false;
                        buttonInitAndStart.Enabled = true;
                        groupBoxCounterInit.Enabled = true;
                        timer1.Enabled = false;
                        labelValue.Visible = false;
                        labelError.Visible = false;
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show("MFSinCosRelease Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            System.UInt64 ulCounterIndex = 0;
            System.UInt64 ulValue = 0;
            Single sValue = 0;
            System.UInt64 ulMeasureError = 0;
            byte[] tmp = new byte[4];

            ulCounterIndex = Convert.ToUInt64(comboBoxCounterIndex.SelectedIndex);
            
            try
            {
                Response = MSXE17xx.MFSinCosRead(ulCounterIndex, 0, 0, 0, 0, out ulValue, out ulMeasureError);
                if (Response.iReturnValue != 0)
                {
                    buttonClear.Enabled = false;
                    buttonStopAndRelease.Enabled = false;
                    buttonInitAndStart.Enabled = true;
                    groupBoxCounterInit.Enabled = true;
                    timer1.Enabled = false;
                    labelValue.Visible = false;
                    labelError.Visible = false;
                    MessageBox.Show("MFSinCosRead Error : " + Response.iReturnValue.ToString() + " syserrno: " + s_GetSysErrnoString(Response.syserrno), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
                else
                {
                    labelError.Text = "Counter error: ";

                    if ((ulMeasureError & 1) == 1)
                        labelError.Text += "amplitude";

                    if ((ulMeasureError & 3) == 3)
                        labelError.Text += " and ";

                    if ((ulMeasureError & 2) == 2)
                        labelError.Text += "frequency";

                    if (ulCounterValueFormat == 0)
                    {
                        labelValue.Text = "Counter value: " + ulValue.ToString("X") + " Hex";                       
                    }
                    else
                    {
                        // Convert the unsigned long into floting point value
                        tmp[0] = Convert.ToByte(ulValue & 0xFF);
                        tmp[1] = Convert.ToByte((ulValue >> 8) & 0xFF);
                        tmp[2] = Convert.ToByte((ulValue >> 16) & 0xFF);
                        tmp[3] = Convert.ToByte((ulValue >> 24) & 0xFF);
                        sValue = BitConverter.ToSingle(tmp, 0);
                        labelValue.Text = "Counter value: " + sValue.ToString("F6") + " mm";
                    }
                }
            }
            catch (Exception ex)
            {
                buttonClear.Enabled = false;
                buttonStopAndRelease.Enabled = false;
                buttonInitAndStart.Enabled = true;
                groupBoxCounterInit.Enabled = true;
                timer1.Enabled = false;
                labelValue.Visible = false;
                labelError.Visible = false;
                MessageBox.Show("MFSinCosRead Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        private void EnableDisable_buttonInitAndStart(object sender, EventArgs e)
        {
            if ((comboBoxCounterIndex.SelectedIndex != -1) && 
                (comboBoxCounterMode.SelectedIndex != -1) &&
                (comboBoxValueFormat.SelectedIndex != -1) &&
                (!(textBoxSignalPeriode.Text.ToString().Contains(",")) && !(textBoxSignalPeriode.Text.ToString().Contains("."))) &&
                (!(textBoxResolution.Text.ToString().Contains(",")) && !(textBoxResolution.Text.ToString().Contains("."))) &&
                ((textBoxSignalPeriode.Text.ToString().Length > 0) && (Convert.ToUInt64(textBoxSignalPeriode.Text.ToString(), 10) > 0)) &&
                ((textBoxResolution.Text.ToString().Length > 0) && (Convert.ToUInt64(textBoxResolution.Text.ToString(), 10) > 0)))
            {
                buttonInitAndStart.Enabled = true;
            }
            else
            {
                buttonInitAndStart.Enabled = false;
            }
        }

        private void comboBoxCounterIndex_SelectedIndexChanged(object sender, EventArgs e)
        {
            EnableDisable_buttonInitAndStart(sender, e);
        }

        private void comboBoxValueFormat_SelectedIndexChanged(object sender, EventArgs e)
        {
            EnableDisable_buttonInitAndStart(sender, e);
        }

        private void textBoxSignalPeriode_TextChanged(object sender, EventArgs e)
        {
            EnableDisable_buttonInitAndStart(sender, e);
        }

        private void textBoxResolution_TextChanged(object sender, EventArgs e)
        {
            EnableDisable_buttonInitAndStart(sender, e);
        }

        private void comboBoxCounterMode_SelectedIndexChanged(object sender, EventArgs e)
        {
            EnableDisable_buttonInitAndStart(sender, e);
        }

        private void InitReadClear_Load(object sender, EventArgs e)
        {
            MX_Global = new MXCommon_WebReference.MXCommon();
            MSXE17xx = new MSXE172x_WebReference.MSXE17xx();
            MX_Global.Timeout = 2000;
            MSXE17xx.Timeout = 2000;
        }

        private void InitReadClear_FormClosing(object sender, FormClosingEventArgs e)
        {
            buttonStopAndRelease_Click(sender, e);
        }
    }
}